#include "stdafx.h"
#include "UnLhaArchiver.h"
#include "ArchiverDll.h"
#include "../String/StringBuilder.h"
namespace Themis {

CUnLhaArchiver::CUnLhaArchiver() {
}

CUnLhaArchiver::~CUnLhaArchiver() {
}

vector<string> CUnLhaArchiver::InnerGetSupportedSuffixes() const {
    vector<string> vct;
    if (CArchiverDll::GetUnLha().IsReady()) {
        vct.push_back(L"lzh");
    }
    return vct;
}

bool CUnLhaArchiver::InnerOpen(vector<SFile>& rList) {
    try {
        CArchiverDll& rDll = CArchiverDll::GetUnLha();
        if (rDll.IsReady()) {
            rDll.WaitForEndRunning();
            if (!rDll.CheckArchive(GetName(), 1 | 4)) {
                throw RuntimeException(L"ɂ̓ǂݍ݂Ɏs܂");
            }
            std::tr1::shared_ptr<CArchiverDll::CFindFile> pFinder = rDll.FindFile(NULL, GetName(),
                0x00000004L | 0x00000200L | 0x00800000L | 0x02000000L | 0x08000000L);
                // M_NO_BACKGROUND_MODE, M_CHECK_FILENAME_ONLY, M_ERROR_MESSAGE_OFF, M_BAR_WINDOW_OFF, M_RECOVERY_ON
            if (pFinder != NULL) {
                do {
                    if (!CFileName(Encoding::GetDefault().GetString(pFinder->GetInfo().szFileName)).IsDirPath()) {
                        rList.push_back(SFile(pFinder->GetInfo()));
                    }
                } while (pFinder->ToNext());
                return true;
            }
        }
    } catch (std::exception&) {
    }
    return false;
}

void CUnLhaArchiver::InnerExtractFile(int nFileIndex, const CFileName& oDirName) {
    CArchiverDll& rDll = CArchiverDll::GetUnLha();
    if (rDll.IsReady()) {
        rDll.WaitForEndRunning();
        StringBuilder cmd = L"x -n1 -jf0 -jn1 -jsb -p1 -gm \""; //𓀁A_CAOA[gL̍폜AbZ[W[v񂳂ȂHA㏑֎~AG[}~
        cmd.Append(GetName());
        cmd.Append(L"\" \"");
        cmd.Append(oDirName.Get());
        cmd.Append(L"\" \"");
        cmd.Append(GetFileName(nFileIndex));
        cmd.Append(L'\"');
        rDll.Command(NULL, cmd.ToString());
    }
}

void CUnLhaArchiver::InnerLoadFile(int nFileIndex, vector<uint8_t>& vctData) {
    CArchiverDll& rDll = CArchiverDll::GetUnLha();
    if (rDll.IsReady()) {
        rDll.WaitForEndRunning();
        StringBuilder cmd = L"-n1 -jf0 -jsb -p1 -gm \""; //_CAOA[gL̍폜AbZ[W[v񂳂ȂHAG[}~
        cmd.Append(GetName());
        cmd.Append(L"\" \"");
        cmd.Append(GetFileName(nFileIndex));
        cmd.Append(L'\"');
        vctData.clear();
        vctData.resize(GetFileSize(nFileIndex));
        if (0 < vctData.size() && !rDll.ExtractMem(NULL, cmd.ToString(), &vctData[0], vctData.size())) {
            throw RuntimeException(L"'" + GetName() + L"'  '" + GetFileName(nFileIndex) + L"' ̓ǂݍ݂Ɏs܂");
        }
    }
}

void CUnLhaArchiver::ConfigDialog(HWND hWnd) {
    CArchiverDll& rDll = CArchiverDll::GetUnLha();
    if (rDll.IsReady()) {
        rDll.WaitForEndRunning();
        char sz[514] = {0};
        rDll.ConfigDialog(hWnd, sz);
    }
}

}
