#pragma once
#include "Token.h"
namespace Themis {

class ICalculatorScanner : private boost::noncopyable {
    EToken m_eToken;
public:
    void Reset() { InnerReset(); ToNext(); }
    EToken GetToken() const { return m_eToken; }
    int GetNum() const { return InnerGetNum(); }
    double GetNumF() const { return InnerGetNumF(); }
    string GetStr() const { return InnerGetStr(); }
    void ToNext() { m_eToken = InnerToNext(); }

private:
    virtual void InnerReset() = 0;
    virtual EToken InnerToNext() = 0;
    virtual int InnerGetNum() const = 0;
    virtual double InnerGetNumF() const = 0;
    virtual string InnerGetStr() const = 0;

};

}
