#pragma once
#include "../DataObject.h"
#include "Storage.h"
#include "Encoder.h"
namespace Themis {

/**
    CConfigConstValue, CConfigValuẽx[XNX
*/
template<class _CStorage, class _CEncoder> class CConfigValueBase { // : private boost::noncopyable
public:
    typedef _CStorage CStorage;
    typedef _CEncoder CEncoder;
    typedef CConfigValueBase<CStorage, CEncoder> CConfigValueBaseT;
    typedef typename CStorage::TName TName;
    typedef typename CStorage::TData TData;
    typedef typename CStorage::TNameParam TNameParam;
    typedef typename CStorage::TDataParam TDataParam;
 // DataObjectŒ`̂łł͗vȂB
 // typedef typename CEncoder::TValue TValue;
 // typedef typename CEncoder::TValueParam TValueParam;
    inline CConfigValueBase() {}
    inline ~CConfigValueBase() {}
 // inline TValue Get() const;
 // inline void Set(TValueParam t);
};

/**
    Storage  Encoder ̋nB
    [U[ << A >> Ȃǂň̂B
*/
template<class CStorage, class CEncoder> class CConfigValue :
    private CConfigValueBase<CStorage, CEncoder>,
    public CDataObjectBase<CConfigValue<CStorage, CEncoder>, typename CEncoder::TValue> {
public:
    inline CConfigValue(CStorage& rStorage, TNameParam oName) : m_rStorage(rStorage), m_oName(oName) {}
    inline ~CConfigValue() {}
    /// f[^̎擾
    inline TValue Get() const {
        return CEncoder::Decode(m_rStorage.Get(m_oName));
    }
    /// f[^̐ݒ
    inline void Set(TValueParam t) {
        m_rStorage.Set(m_oName, CEncoder::Encode(t));
    }
private:
    CStorage&   m_rStorage;
    TName       m_oName;
};

}
