#pragma once
namespace Themis {

class CWindow;
class WorkerThreadController;

/**
    wbJ[\𓮂ȂΉB@\B
*/
class CCursorHider {
public:
    CCursorHider(CWindow& rWindow);
    ~CCursorHider();

    bool IsEnable() const;
    void SetEnable(bool b);

    int GetTimeout() const;
    void SetTimeout(int nMilliSec);

    /// J[\ꂽȂɌĂ
    void Reset();

    /// \Ԃɂ
    void ForceHide();
    /// \Ԃ
    void UnforceHide();
    /// ForceHideԂ̐ݒ
    void SetForceHide(bool b) { b ? ForceHide() : UnforceHide(); }

private:
    void InnerReset();
    void OnThread();
    bool IsWindowValid();
    void InnerShow();
    void InnerHide();

private:
    CWindow&        m_rWindow;
    int             m_nTimeout;
    CPoint          m_ptCursor;
    volatile bool   m_bHide;
    volatile bool   m_bForceHide;

    volatile bool threadValid;
    std::tr1::shared_ptr<WorkerThreadController> thread;
    boost::recursive_mutex mutex;
    boost::condition condition;
};

}
