#pragma once
#include "Utility/StringUtility.h"
namespace Themis {

/// TU ̌^ϊsBKɓꉻĒ`ׂB
template<class T, class U> struct CDataObjectTranslator {
    //static T Translate(const U& u);
};


/**
    pāׂB(constƂQƂƂ͂Ɍ炸K)
    void Set(TValueParam t);
    TValue Get() const;

    T:       hNX
    TValue:  f[^^B CHogeAint ȂǁB


    ၫ
@code

class CConfigBoolData : public CDataObjectBase<CConfigBoolData, bool> {
public:
    CConfigBoolData(CConfig& r, const string& s) : m_r(r), m_s(s) {}
    void Set(TValueParam oValue) { m_r.Bool(m_s, oValue); }
    TValue Get() const { return m_r.Bool(m_s); }
private:
    CConfig& m_r;
    string m_s;
};

@endcode

*/
template<class T, class _TValue> class CDataObjectBase {
public:
    typedef _TValue TValue;
    typedef typename boost::call_traits<TValue>::param_type TValueParam;
    //@{ CDataObjectBase<FX, FX>Ƃ̂Ƃ
    template<class T2, class TValue2> inline T& operator<<(const CDataObjectBase<T2, TValue2>& t) {
        static_cast<T*>(this)->Set(CDataObjectTranslator<TValue, TValue2>::Translate(static_cast<const T2&>(t).Get()));
        return *static_cast<T*>(this);
    }
    template<class T2, class TValue2> inline const T& operator>>(CDataObjectBase<T2, TValue2>& t) const {
        static_cast<T2&>(t).Set(CDataObjectTranslator<TValue2, TValue>::Translate(static_cast<const T*>(this)->Get()));
        return *static_cast<const T*>(this);
    }
    //@}
    //@{ CDataObjectBase<FX, TValue>Ƃ̂Ƃ
    template<class T2> inline T& operator<<(const CDataObjectBase<T2, TValue>& r) {
        static_cast<T*>(this)->Set(static_cast<const T2&>(r).Get());
        return *static_cast<T*>(this);
    }
    template<class T2> inline const T& operator>>(CDataObjectBase<T2, TValue>& r) const {
        static_cast<T2&>(r).Set(static_cast<const T*>(this)->Get());
        return *static_cast<const T*>(this);
    }
    //@}
    //@{ FXƂ̂Ƃ
    template<class TValue2> inline T& operator<<(typename boost::call_traits<TValue2>::param_type t) {
        static_cast<T*>(this)->Set(CDataObjectTranslator<TValue, TValue2>::Translate(t));
        return *static_cast<T*>(this);
    }
    template<class TValue2> inline const T& operator>>(typename boost::call_traits<TValue2>::reference t) const {
        t = CDataObjectTranslator<TValue2, TValue>::Translate(static_cast<const T*>(this)->Get());
        return *static_cast<const T*>(this);
    }
    //@}
    //@{ ʏ̃f[^Ƃ̂Ƃ
    inline T& operator<<(typename boost::call_traits<TValue>::param_type t) {
        static_cast<T*>(this)->Set(t);
        return *static_cast<T*>(this);
    }
    inline const T& operator>>(typename boost::call_traits<TValue>::reference t) const {
        t = static_cast<const T*>(this)->Get();
        return *static_cast<const T*>(this);
    }
    //@}

    //@{ constǂɂoperator<<, operator>>ĂѕBӂĎg悤ɁB
    template<class T2, class TValue2> inline T& operator&(const CDataObjectBase<T2, TValue2>& t) { return operator<<(t); }
    template<class T2, class TValue2> inline const T& operator&(CDataObjectBase<T2, TValue2>& t) const { return operator>>(t); }
    template<class T2> inline T& operator&(const CDataObjectBase<T2, TValue>& r) { return operator<<(r); }
    template<class T2> inline const T& operator&(CDataObjectBase<T2, TValue>& r) const { return operator>>(t); }
    template<class TValue2> inline T& operator&(typename boost::call_traits<TValue2>::param_type t) { return operator<<(t); }
    template<class TValue2> inline const T& operator&(typename boost::call_traits<TValue2>::reference t) const { return operator>>(t); }
    inline T& operator&(typename boost::call_traits<TValue>::param_type t) { return operator<<(t); }
    inline const T& operator&(typename boost::call_traits<TValue>::reference t) const { return operator>>(t); }
    //@}
};

//@{ ɔDataObjectꍇ́B𓝈ꂷׂɒ`ȂĂ̂AȂBB
template<class T, class TValue> inline void operator<<(typename boost::call_traits<TValue>::reference t, const CDataObjectBase<T, TValue>& r) { r >> t; }
template<class T, class TValue> inline void operator>>(typename boost::call_traits<TValue>::param_type t, CDataObjectBase<T, TValue>& r) { r << t; }
template<class T, class TValue, class TValue2> inline void operator<<(typename boost::call_traits<TValue2>::reference t, const CDataObjectBase<T, TValue>& r) { r >> t; }
template<class T, class TValue, class TValue2> inline void operator>>(typename boost::call_traits<TValue2>::param_type t, CDataObjectBase<T, TValue>& r) { r << t; }
//@}

//@{ CDataObjectTranslator̓ꉻBƂ肠KɁB肷Ɩ󕪂oOɂȂ肩˂Ȃ̂ŒӁB
template<> struct CDataObjectTranslator<string, int> {
    static string Translate(int u) { return ItoA(u); }
};
template<> struct CDataObjectTranslator<int, string> {
    static int Translate(const string& u) { return AtoI(u); }
};
template<> struct CDataObjectTranslator<string, float> {
    static string Translate(float u) { return FtoA(u); }
};
template<> struct CDataObjectTranslator<float, string> {
    static float Translate(const string& u) { return static_cast<float>(AtoF(u)); }
};
template<> struct CDataObjectTranslator<string, double> {
    static string Translate(double u) { return FtoA(u); }
};
template<> struct CDataObjectTranslator<double, string> {
    static double Translate(const string& u) { return AtoF(u); }
};
template<> struct CDataObjectTranslator<bool, int> {
    static bool Translate(int u) { return u != 0; }
};
template<> struct CDataObjectTranslator<int, bool> {
    static int Translate(bool u) { return u ? 1 : 0; }
};
//@}


}
