/** @file
 * t@CɊւ镶񏈗ƂB
 *
 * @author aki.
 */
#pragma once
namespace Themis {

/**
    t@CIuWFNgB

    ΃pXEtpXElbg[NpXɑΉB

    fBNgȂRXgN^́A
    GetSuffixLc()ƂĂяo̎ĝăIuWFNgA
    XtpXȂǂł鎖ۏ؂ĂꍇɁB

    󂾂肷̂̃`FbNƂAgԈĂ悤Ȃ̂
    {IDebugAssertƂ`FbNȂ̂ŒӂĎgׂB
*/
class CFileName : private boost::totally_ordered<CFileName> {
public:
    /// ƕsւƂȏꍇ̂ŁAȏԂAƂɂĂ܂B
    CFileName() {}
    /// ŒڃoցBϐƂ/Ƃ蓾ꍇNoDirgׂB
    explicit CFileName(const string& strFullName): m_strName(strFullName) {};
    /// fBNgƂstrBaseDirg
    CFileName(const string& strFileName, const string& strBaseDir);
    /// fBNgƂoBaseDirg
    CFileName(const string& strFileName, const CFileName& oBaseDir);
    /// łƂ炭B
    ~CFileName();

    /// ȏԂȂtrue
    bool IsEmpty() const { return m_strName.GetLength() <= 0; }
    /// t@CŜ擾
    const string& Get() const { return m_strName; }

    /// gq擾
    string GetSuffix() const;
    /// gqɕϊĎ擾
    string GetSuffixLc() const;
    /// fBNgEgq̂擾
    string GetPrefix() const;
    /// fBNĝ擾(GetPrefix() + L'.' + GetSuffix())
    string GetPureName() const;
    /// fBNgtpXɕϊĎ擾
    string GetDir() const;
    /// fBNgł[fBNg̖O擾Bt@CȂ炻̃t@ĈfBNg̖OB
    string GetDirName() const;
    /// fBNg̃fBNg擾Bt@CȂ炻̃t@ĈfBNgB
    string GetParentDir() const;
    /// hCu^[̎擾BL'/'Ȃlbg[NpX
    wchar_t GetDriveLetter() const;
    /// oDirNameƂ΃pX̍쐬BnMaxUp../̍őB-1ŖB
    string GetRelativeName(const CFileName& oDirName, int nMaxUp = -1) const;
    /// ɃfBNg؂蕶ΕtO擾
    string AddDirSeparator() const;
    /// ̃fBNg؂蕶΂O擾
    string RemoveDirSeparator() const;
    /// ̃fBNg؂蕶΂O擾AC:Ƃ
    string RemoveDirSeparatorForce() const;
    /// gqύXt@C쐬
    CFileName SetSuffix(const string& strSuffix) const;
    /// vtBNXύXt@C쐬
    CFileName SetPrefix(const string& strPrefix) const;
    /// vtBNXƊgqύXt@C쐬
    CFileName SetPureName(const string& strPureName) const;
    /// fBNgύXt@C쐬
    CFileName SetDir(const CFileName& oDir) const;

    /// t@C̓lbg[NpXȂ̂ǂ
    bool IsNetworkPath() const { return 2 < m_strName.GetLength() && IsSeparator(m_strName[0]) && IsSeparator(m_strName[1]); }
    /// t@C̓tpXȂ̂ǂ
    bool IsFullPath() const { return 2 < m_strName.GetLength() && m_strName[1] == L':'; }
    /// t@ClgNpXłtpXłꍇtrue
    bool IsRelativePath() const { return m_strName.GetLength() <= 2 || (m_strName[1] != L':' && !(IsSeparator(m_strName[0]) && IsSeparator(m_strName[1]))); }
    /// t@C̓fBNg̖OȂ̂ǂ(Zp[^[Ȃ̂Ŕʂ)
    bool IsDirPath() const { return 0 < m_strName.GetLength() && IsSeparator(m_strName[m_strName.GetLength() - 1]); }
    /// "C:\\"ƂȂtrue
    bool IsRootPath() const { return m_strName.GetLength() == 3 && m_strName[1] == L':'; }

    /// (m[`FbNϊƂȂ̂Œӂ邱)
    CFileName& operator=(const string& s) { m_strName = s; return *this; }
    //@{ ̕t(m[`FbNϊƂȂ̂Œӂ邱)
    CFileName& operator+=(const string& s) { m_strName += s; return *this; }
    //@}

    //@{ rZq
    bool operator==(const CFileName& r) const;
    bool operator<(const CFileName& r) const;
    //@}

    /// fBNg̕ύX
    void SetBaseDir(const string& strBaseDir);

//ȉ̊֐͒ǉE폜̊mB(ʏ͊OgpKv͖)
//private:
    /// Ɂ
    static string AddDirSeparator(const string& str);
    /// ́菜iC:ƂȊOj
    static string RemoveDirSeparator(const string& str);
    /// C:Ƃ C: ɂ RemoveDirSeparator();
    static string RemoveDirSeparatorForce(const string& str);
    /// ^ɒu
    static string SlashToYen(const string& str);
    /// fBNg̋؂蕶Ȃ̂ǂ
    static inline bool IsSeparator(wchar_t c) { return (c == L'\\' || c == L'/'); }
    /// L'\\'Ȃ̂ǂ
    static inline bool IsYen(wchar_t c) { return c == L'\\'; }
    /// ԍṒ^Ƃ̈ʒu擾(ȂΕl)
    static int GetLastSeparatorPos(const string& str);
    /// gqƃt@C̋؂ . ̈ʒu擾(ȂΕl)
    static int GetLastDotPos(const string& str);

private:
    string m_strName;
};


/**
    fBNgƂexêtH_gFileName
*/
class CFileNameModuleDir: public CFileName {
public:
    CFileNameModuleDir();
    CFileNameModuleDir(const string& strFileName);
};


/**
    fBNgƂăVXẽJgfBNggFileName
*/
class CFileNameSystemDir: public CFileName {
public:
    CFileNameSystemDir();
    CFileNameSystemDir(const string& strFileName);
};

/**
    fBNgw肵ȂFileNameBϐ̒u /  \\ ̂݁B
*/
class CFileNameNoDir: public CFileName {
public:
    CFileNameNoDir(const string& strFileName);
};

}
