#include "stdafx.h"
#include "Timer.h"
#include "FpsTimer.h"
namespace Themis {

CFpsTimer::CFpsTimer(int nFps, int nMaxSkipFrame) {
    CTimer::Begin();
    SetFps(nFps, nMaxSkipFrame);
    Reset();
}
CFpsTimer::~CFpsTimer() {
    CTimer::End();
}

void CFpsTimer::SetFps(int nFps, int nMaxSkipFrame) {
    m_fFrameTime = (0 < nFps) ? ToFint(1000)/nFps : ToFint(0);
    m_nMaxSkip = nMaxSkipFrame;
}

void CFpsTimer::Reset() {
    m_fLastTime = ToFint(CTimer::Get());
    m_nSkipCount = 0;
    m_nLastCulcTime = 0;
    m_nFrameCount = 0;
    m_nNowFps = 0;
}

void CFpsTimer::WaitFrame() {
    //FPS̒
    if (ToFint(0) < m_fFrameTime) {
        fint fNow = ToFint(CTimer::Get());
        fint fElp = fNow - m_fLastTime;                  //
        int nNowWait = FintToInt(m_fFrameTime - fElp);   //҂(+҂1t[ƂȂ)
        if (0 <= nNowWait) {
            CTimer::SleepStrict(nNowWait);
            m_fLastTime += m_fFrameTime;    //҂EFCgoƂɂ
            m_nSkipCount = 0;
        } else if (FintToInt(m_fFrameTime/2) <= -nNowWait) {
            //1.5t[ȏ㏈xĂꍇ
            if (0 < m_nMaxSkip) {
                if (m_nSkipCount < m_nMaxSkip) {
                    m_nSkipCount++;
                    m_fLastTime += m_fFrameTime;    //҂̎Ԃł܂ɂƂ
                } else {
                    //XLbvĂ邩x`悷
                    m_fLastTime = fNow;     //ݎ
                    m_nSkipCount = 0;
                }
            } else {
                m_fLastTime = fNow;     //ݎ
            }
        } else {
            //҂XLbv
            m_fLastTime += m_fFrameTime;
        }
    }

    //FPSľvZ
    ++m_nFrameCount;
    const unsigned nNow = CTimer::Get();
    const int nElp = nNow - m_nLastCulcTime;
    if (3000 < nElp) { // Rbȏ̕ςŏ
        m_nNowFps = (0 < nElp) ? (m_nFrameCount * 1000 / nElp) : (m_nFrameCount * 1000);
        m_nLastCulcTime = nNow;
        m_nFrameCount = 0;
    }
}

}
