#pragma once
#include "Plane32.h"
namespace Themis {

/**
    HDCȂv[B

*/
class CMemoryPlaneImpl : public IPlaneImpl {
public:
    CMemoryPlaneImpl();
    virtual ~CMemoryPlaneImpl();

    bool IsCreated() const;
    void Create(const CSize& sz, int nBpp);
    void Delete();
    CSize GetSize() const;
    bool IsReAllocatable() const { return true; }
    bool IsGdiSupport() const { return false; }
    bool IsDirectX() const { return false; }
    pair<void*, int> Lock();
    void Unlock(const pair<void*, int>& p) {}
    HDC GdiLock() { return NULL; }
    void GdiUnlock(HDC hdc) {}

private:
    uint8_t* memory;
    int pitch;
    CSize size;
};

class CMemoryPlane : public CPlane {
public:
    CMemoryPlane(int nBpp): CPlane(std::tr1::shared_ptr<IPlaneImpl>(new CMemoryPlaneImpl), nBpp) {}
};

class CMemoryPlane8 : public CPlane8 {
public:
    CMemoryPlane8(): CPlane8(std::tr1::shared_ptr<IPlaneImpl>(new CMemoryPlaneImpl)) {}
    CMemoryPlane8(const CSize& sz) : CPlane8(std::tr1::shared_ptr<IPlaneImpl>(new CMemoryPlaneImpl)) { SetSize(sz); }
};

class CMemoryPlane32 : public CPlane32 {
public:
    CMemoryPlane32(): CPlane32(std::tr1::shared_ptr<IPlaneImpl>(new CMemoryPlaneImpl)) {}
    CMemoryPlane32(const CSize& sz): CPlane32(std::tr1::shared_ptr<IPlaneImpl>(new CMemoryPlaneImpl)) { SetSize(sz); }
};

}
