#pragma once
#include "../Clipper.h"
#include "PlaneImpl.h"
namespace Themis {

/**
    |C^ɂANZX(ƁAHDCɂANZX)̉\ȕʁB

    FillAقȂtH[}bgmBltT|[gB
    ΉBPP8(mN), 16(BGR555), 24(BGR888), 32(BGRA8888)̂݁B

    摜̓ǂݍ݂CImageLoaderAoC???Saver𒼐ڎgׂB
*/
class CPlane : private boost::noncopyable {
public:
    /// MMXĝ
    static bool IsUseMMX();
    /// MMXĝ
    static void SetUseMMX(bool b);
    /// 3DNowĝ
    static bool IsUse3DNow();
    /// 3DNowĝ
    static void SetUse3DNow(bool b);
    /// Parallelĝ
    static bool IsUseParallel();
    /// Parallelĝ
    static void SetUseParallel(bool b);

    CPlane(const std::tr1::shared_ptr<IPlaneImpl>& pImpl, int nBpp): m_pImpl(pImpl), m_nBpp(nBpp), m_oSize(-1, -1) {}
    virtual ~CPlane() {}

    /// 쐬Ă̂ǂ
    bool IsCreated() const { return m_pImpl->IsCreated(); }
    /// v[szȏ̑傫ۏ؂
    void SetSize(const CSize& sz);
    /// ݐݒ肳ĂTCY̎擾
    CSize GetSize() const { return m_oSize; }
    /// ݊mۂĂTCY̎擾
    CSize GetCapacity() const { return m_pImpl->GetSize(); }
    /// Iɉ
    void Delete() { m_oSize = CSize(); m_pImpl->Delete(); }
    /// HDC擾ł邩ǂ
    bool IsGdiSupport() const { return m_pImpl->IsGdiSupport(); }
    /// DirectXȂ̂ǂ
    bool IsDirectX() const { return m_pImpl->IsDirectX(); }
    /// F[x̎擾
    int GetBpp() const { return m_nBpp; }

    //@{ hԂEP]
    virtual void Fill(COLORREF rgb);
    virtual void Fill(COLORREF rgb, CRect rc);
    virtual void Blt(const CPlane& rSrc, const CClipper& rClip = CClipper());
    virtual void Blt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    //@}
    /// DIBBlt
    virtual void BltFromDIBits(const BITMAPINFO& rBmpInfo, const void* pBits, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());

    /// v[ւ̃|C^擾
    class CLock : private boost::noncopyable {
    public:
        inline CLock(const CPlane& r) : m_r(*r.m_pImpl), m_bpp(r.GetBpp() / 8), m_p(r.m_pImpl->Lock()) {}
        inline ~CLock() { m_r.Unlock(m_p); }
        inline int GetPitch() const { return m_p.second; }
        inline uint8_t* GetByte(const CPoint& pt = CPoint()) const {
            return (static_cast<uint8_t*>(m_p.first) + pt.x * m_bpp + pt.y * m_p.second);
        }
        inline uint16_t* GetWord(const CPoint& pt = CPoint()) const {
            return reinterpret_cast<uint16_t*>(GetByte(pt));
        }
        inline uint32_t* GetDWord(const CPoint& pt = CPoint()) const {
            return reinterpret_cast<uint32_t*>(GetByte(pt));
        }
    private:
        IPlaneImpl& m_r;
        const int m_bpp;
        const pair<void*, int> m_p;
    };
    /// HDC擾
    class CGdiLock : private boost::noncopyable {
    public:
        inline CGdiLock(const CPlane& r) : m_r(*r.m_pImpl), m_h(r.m_pImpl->GdiLock()) {}
        inline ~CGdiLock() { m_r.GdiUnlock(m_h); }
        inline operator HDC() const { return m_h; }
        inline HDC Get() const { return m_h; }
    private:
        IPlaneImpl& m_r;
        const HDC m_h;
    };

    /// ÔߎIuWFNg̒ڎ擾
    IPlaneImpl& GetImpl() const { return *m_pImpl; }

protected:
    void SetSizeIndirect(const CSize& sz) { m_oSize = sz; }

private:
    void BltFromDIBits32(const BITMAPINFO& rBmpInfo, const void* pBits, CPoint ptDst, CRect rcSrc, const CClipper& rClip);
    void BltFromDIBitsGDI(const BITMAPINFO& rBmpInfo, const void* pBits, CPoint ptDst, CRect rcSrc, const CClipper& rClip);

private:
    std::tr1::shared_ptr<IPlaneImpl>   m_pImpl;
    const int               m_nBpp;
    CSize                   m_oSize;
};

}
