#pragma once
#include "FontStyle.h"
namespace Themis {

class CPlaneEx;
class CPlane32;

/**
    `NXB

    FontStyle󂯎ĕ`悷邾B

    RsypTv
@code

namespace Themis {
    class CFont;
}

@endcode@code

    auto_ptr<CFont>     m_pFont;

@endcode@code

#include <Themis/Font.h>

@endcode@code

        CFontStyle fs;
        fs.SetFace(L"");
        fs.SetHeight(20);
        fs.SetWeight(CFontStyle::eWeightNormal);
        fs.SetColor(RGB(0xff, 0xff, 0xff));
        fs.SetItalic(false);
        fs.SetUnderLine(false);
        fs.SetStrikeOut(false);
        fs.SetShadowType(1);
        fs.SetShadowColor(RGB(0x00, 0x00, 0x00));
        fs.SetShadowGap(1);
        fs.SetBg(false);
        fs.SetBgColor(RGB(0x00, 0x00, 0x00));
        fs.SetAntiAlias(false);
        m_pFont.reset(new CFont(fs));

@endcode@code

        CSize szText = m_pFont->GetSize(strText);
        m_pFont->DrawText(dst, pt, strText);

@endcode
*/
class CFont : private boost::noncopyable {
public:
    CFont(const CFontStyle& rFontStyle);
    ~CFont();

    /// ̎擾
    const CFontStyle& GetStyle() const { return m_fs; }

    /// ̏c擾
    int GetLineHeight(int nLine = 1) const;
    /// ̑傫擾
    CSize GetSize(const string& strText);

    /// ̕`
    void DrawText(CPlaneEx& rDst, const CPoint& pt, const string& strText);
    /// ̕`悻̂Q
    void DrawText(HDC hdc, const CPoint& pt, const string& strText);

protected:
    /// e≏̑傫擾
    int GetShadowGapSize() const;

private:
    void InnerDrawText(HDC hDst, const CPoint& pt, const string& strText);
    void InnerDrawTextLine(HDC hDst, const CPoint& pt, const string& strText);
    void InnerDrawTextAA(CPlane32& rDst, const CPoint& pt, const string& strText);
    void InnerDrawTextLineAA(CPlane32& rDst, const CPoint& pt, const string& strText);
    void InnerTextOutLineAA(CPlane32& rDst, const CPoint& pt, const string& strText, COLORREF rgbFont);

private:
    CFontStyle  m_fs;
    HFONT       m_hFont;
};

}
