#pragma once
#include "../Factory.h"
#include "../FileData.h"
#include "../Stream.h"
namespace Themis {

class CPlane;
class CMemoryPlane;

/// 摜̓ǂݍݎsȗO
class ImageLoadException : public RuntimeException {
public:
    ImageLoadException() : RuntimeException(L"摜̓ǂݍ݂Ɏs܂") {}
    ImageLoadException(const CFileName& name)
        : RuntimeException(name.Get() + L" ̉摜ǂݍ݂Ɏs܂") {}
};

/// 摜̕ۑsȗO
class ImageSaveException : public RuntimeException {
public:
    ImageSaveException() : RuntimeException(L"摜̕ۑɎs܂") {}
    ImageSaveException(const CFileName& name)
        : RuntimeException(name.Get() + L" ̉摜ۑɎs܂") {}
};

/**
    摜ǂݍ݃IuWFNg̊NXB

    ׂ
    void Load(const std::tr1::shared_ptr<CFileData>& fileData, bool bRenderOnlyAtOnce);
    CSize GetSize() const;
    void Render(CPlane& dst, const CPoint& pt, bool bRenderOnlyAtOnce) const;
    bool HasAlpha() const;
    string GetTypeName() const;
    string GetTypeFileName() const;
*/
class IImageLoader : private boost::noncopyable {
public:
    virtual ~IImageLoader() {}
    /// 摜ǂݍ
    virtual bool Load(const std::tr1::shared_ptr<CFileData>& fileData, bool bRenderOnlyAtOnce) = 0;
    /// ǂݍ񂾉摜̑傫擾
    virtual CSize GetSize() const = 0;
    /// ǂݍ񂾉摜`悷
    virtual void Render(CPlane& dst, const CPoint& pt, bool bRenderOnlyAtOnce) = 0;
    /// `lĂƎvȂtrue
    virtual bool HasAlpha() const = 0;
    /// 摜̎ނ̎擾
    virtual string GetTypeName() const = 0;
    /// 摜̕W̊gq擾(FL"*.jpg;*.jpeg")
    virtual string GetTypeFileName() const = 0;
};


/**
    factory listɓo^ĂLoaderœǂݍށB

    IsLoadabletrueȎLoadĂ̂͌ꍇ̂ŁA
    LoadableȂ̂m߂ȊO͂ȂLoadgׂB

    RsypTv
@code

    // t@Cnhgnƃڌn or HDCgnƎgȂnAꍇɂĕѕƂHvׂ)
    CImageLoader::GetFactoryList().Add(new CPngLoaderFactory);
    CImageLoader::GetFactoryList().Add(new CJpgLoaderFactory);
    CImageLoader::GetFactoryList().Add(new CArgbLoaderFactory);
    CImageLoader::GetFactoryList().Add(new CBmpLoaderFactory);
    CImageLoader::GetFactoryList().Add(new CTgaLoaderFactory);
    CImageLoader::GetFactoryList().Add(new COleLoaderFactory);
    CImageLoader::GetFactoryList().Add(new CSpiLoaderFactory(CFileNameModuleDir(L"./spi/")));

@endcode
    CSpiLoaderFactorýAISPIfBNgύXꍇAŃCX^X
@code

    std::tr1::shared_ptr<CSpiLoaderFactory> m_pSpiLoaderFactory;
    CImageLoader::GetFactoryList().Add(m_pSpiLoaderFactory);

@endcode
    Ƃ̂AB


        bFILE*b HDC b
    ||{||||||{
    argbb     b     b
    png b     b     b
    jpg b     b     b
    bmp b     b   b
    ole b     b   b
    spi b     b   b
    ||{||||||{

*/
class CImageLoader : private boost::noncopyable {
public:
    CImageLoader();
    ~CImageLoader();

    //@{ PxRenderĂяoȂĂꍇALoad()̑Otrueɐݒ肵ƂB
    void SetRenderOnlyAtOnce(bool b);
    bool IsRenderOnlyAtOnce() const;
    //@}

    /// 摜ǂݍ
    void Load(const std::tr1::shared_ptr<CFileData>& pFileData);
    /// ǂݍ񂾉摜̑傫擾
    CSize GetSize() const;
    /// ǂݍ񂾉摜`悷
    void Render(CPlane& dst, const CPoint& pt = CPoint());
    /// `lĂƎvȂtrue
    bool HasAlpha() const;
    /// 摜̎ނ̎擾
    string GetTypeName() const;

    /**
     * ȒPȉ摜ǂݍ݃[`B
     * @param p 摜t@Cf[^
     * @param rPlane ǂݍ񂾉摜̕`v[
     * @return ǂݍ񂾉摜̑傫
     */
    static CSize Load(CPlane& rPlane, const std::tr1::shared_ptr<CFileData>& pFileData);
    /// std::tr1::shared_ptrexplicitʓ|Ȃ̂ŁBB
    static CSize Load(CPlane& rPlane, CFileData* p) { return Load(rPlane, std::tr1::shared_ptr<CFileData>(p)); }

    /// ΉĂƎv킵gq̃Xg擾
    static vector<string> GetSupportedSuffixesLc();

    /// Load/IsLoadablefactorỹXg
    static FactoryList<IImageLoader>& GetFactoryList();

private:
    std::tr1::shared_ptr<CFileData> m_pFileData;
    std::tr1::shared_ptr<IImageLoader> m_pLoader;
    int m_nRenderFlag;  //0:xłǂݍ߂ŁA1:`A2:`ς
};

/**
    摜oIuWFNg̊NXB

    NXӖLoader͖ǂA
    ǂ̌`ŏoIɑI񂾂肷ꍇƂ
    ֗Ȃ悤ȋCȂłȂB

    ׂ
    void Save(const CFileName& oFileName, const CPlane& src, const CRect& rc);
*/
class IImageSaver : private boost::noncopyable {
public:
    virtual ~IImageSaver() {}
    virtual void Save(const CFileName& oFileName, const CPlane& src, const CRect& rc) = 0;
};

}
