#pragma once
#include "Image.h"
#include "../SPI.h"
namespace Themis {

class CDll;
class CSpiLoaderFactory;

/**
    Spig摜̓ǂݍ݃NXB
*/
class CSpiLoader: public IImageLoader {
public:
    CSpiLoader(const std::tr1::shared_ptr<CSpi>& pSpi);
    ~CSpiLoader();
    bool Load(const std::tr1::shared_ptr<CFileData>& fileData, bool bRenderOnlyAtOnce);
    CSize GetSize() const;
    void Render(CPlane& dst, const CPoint& pt, bool bRenderOnlyAtOnce);
    bool HasAlpha() const;
    string GetTypeName() const;
    string GetTypeFileName() const;

private:
    bool InnerLoad(const CFileName& fileName, const void* pMemory, size_t nSize);

private:
    std::tr1::shared_ptr<CSpi>     m_pSpi;
    HLOCAL              m_hBits;
    HLOCAL              m_hBmInfo;
    SPI::PictureInfo    m_oPictureInfo;
    string              m_strTypeName;
    int                 m_nAlphaFlag; // 0:ݒA1:ȂA2:
};

/**
    CSpiLoaderFactoryB

    ̃NX̃CX^XĂ΁A
    IɌfBNgς邱Ƃ\B
*/
class CSpiLoaderFactory: public IFactory<IImageLoader> {
public:
    CSpiLoaderFactory() {}
    CSpiLoaderFactory(const CFileName& oSpiDir) { SetDir(oSpiDir); }
    CSpiLoaderFactory(const std::tr1::shared_ptr<CSpi>& p): m_pPluginList(p) {}
    ~CSpiLoaderFactory() {}
    /// CX^X̍쐬
    virtual std::tr1::shared_ptr<IImageLoader> CreateInstance();
    /// SPIt@CfBNgݒ
    void SetDir(const CFileName& oSpiDir);
    /// SPIXg̐ݒ
    void SetSpi(const std::tr1::shared_ptr<CSpi>& p) { m_pPluginList = p; }
    /// fBNg̎擾
    const CFileName& GetDir() const { return m_pPluginList->GetDir(); }

private:
    std::tr1::shared_ptr<CSpi> m_pPluginList;
};

}
