#pragma once
namespace Themis {

/**
    ImageList̒Pȃbp[B
*/
class CImageList : private boost::noncopyable {
public:
    CImageList(const CSize& szImage, int nCapacity);
    ~CImageList();

    int Add(HICON hIcon);
    int Add(HBITMAP hBmp, HBITMAP hBmpMask = NULL);
    int Add(HBITMAP hBmp, COLORREF rgbMask);

    void* GetHandle() const { return m_hImageList; }

private:
    void*   m_hImageList;   //HIMAGELIST
};


/**
    Xgr[p̃ACRXgB
*/
class CIconImageList : private boost::noncopyable {
public:
    CIconImageList(bool bSmall = true);
    ~CIconImageList();

    /// ő̐ݒBnh̒lς̂ŒӁB
    void SetSize(int n);
    /// t@CACR擾AImageListɒǉăCfbNXԂ
    int Add(const CFileName& oFileName);

    /// ACRȂ̂ǂ
    bool IsSmallIcon() const { return m_bSmall; }
    /// HIMAGELIST̎擾
    void* GetHandle() const { return m_pImageList->GetHandle(); }

private:
    const bool              m_bSmall;
    auto_ptr<CImageList>    m_pImageList;
};

class WorkerThreadController;

/**
    ʃXbhŃACRǂݍݏsIuWFNgB
*/
class CIconLoader : private boost::noncopyable {
public:
    /**
        ǂݍ݊̒ʒm󂯎NXB
    */
    class IListener {
    public:
        virtual ~IListener() {}
        virtual void OnIconLoaded(const CFileName& oFileName, int nParam, int nIndex) = 0;
    };

    CIconLoader(IListener& rListener, bool bSmall = true);
    ~CIconLoader();

    /// ő̐ݒ(ǂݍ݂̓LZ)
    void SetSize(int n);
    /// ǂݍ݃X^bNɐς
    void Load(const CFileName& oFileName, int nParam);

    const CIconImageList& GetList() const { return *m_pIconImageList; }

private:
    void OnThread();

    struct SEntry {
        CFileName oFileName;
        int nParam;
    };

private:
    IListener& m_rListener;

    volatile bool threadValid;
    std::tr1::shared_ptr<WorkerThreadController> thread;
    boost::mutex mutex;
    boost::condition condition;

    auto_ptr<CIconImageList>m_pIconImageList;
    std::list<SEntry> m_oLoadQueue;
    volatile bool m_bCancel;
};


}
