#include "stdafx.h"
#include "Window.h"
#include "HotKey.h"
#include "KeyConfig.h"
namespace Themis {

CKeyConfig::CKeyConfig() {
}

CKeyConfig::~CKeyConfig() {
}

void CKeyConfig::Clear() {
    m_vctData.clear();
    m_oId2Index.clear();
}

void CKeyConfig::Add(int nHotKeyId, const string& viewName, int nCommand) {
    Themis_DebugAssert(m_oId2Index.find(nHotKeyId) == m_oId2Index.end());
    m_oId2Index.insert(make_pair(nHotKeyId, static_cast<int>(m_vctData.size())));
    SData oData;
    oData.viewName = viewName;
    oData.nCommand = nCommand;
    m_vctData.push_back(oData);
}

void CKeyConfig::Remove(int nHotKeyId) {
    // nHotKeyIdȊÔoTmpփRs[
    CKeyConfig oTmp;
    for (std::map<int, int>::const_iterator it = m_oId2Index.begin(); it != m_oId2Index.end(); ++it) {
        if (it->first != nHotKeyId) {
            oTmp.Add(it->first, GetViewName(it->second), GetCommandId(it->second));
        }
    }
    // g[
    m_vctData.swap(oTmp.m_vctData);
    m_oId2Index.swap(oTmp.m_oId2Index);
}

void CKeyConfig::UpdateMenubar(HMENU hMenu, CHotKey& rHotKey) const {
    CMenu oMenu(hMenu);
    for (std::map<int, int>::const_iterator it = m_oId2Index.begin(); it != m_oId2Index.end(); ++it) {
        string str = oMenu.GetText(GetCommandId(it->second));
        List<string> vct = str.Split(Array<string>(L"\t"));
        if (!vct.empty()) {
            string strKey = rHotKey.GetKeyStr(it->first);
            string str2 = string::IsNullOrEmpty(strKey) ? vct[0] : vct[0] + L"\t" + strKey;
            if (str != str2) { // Ă鎞ύX
                oMenu.SetText(GetCommandId(it->second), str2);
            }
        }
    }
}

/// j[Lȏꍇ̂SendCommand()Bʂ͂gׂ
void CKeyConfig::SendCommandOnEnable(HWND hWnd, HMENU hMenu, int nHotKeyId) const {
    CMenu oMenu(hMenu);
    std::map<int, int>::const_iterator it = m_oId2Index.find(nHotKeyId);
    if (it != m_oId2Index.end()) {
        int nCommandId = GetCommandId(it->second);
        if (oMenu.IsEnabled(nCommandId)) {
            CWnd(hWnd).SendMsg(WM_COMMAND, nCommandId, 0);
        }
    }
}

void CKeyConfig::SendCommand(HWND hWnd, int nHotKeyId) const {
    std::map<int, int>::const_iterator it = m_oId2Index.find(nHotKeyId);
    if (it != m_oId2Index.end()) {
        CWnd(hWnd).SendMsg(WM_COMMAND, GetCommandId(it->second), 0);
    }
}

int CKeyConfig::GetIdFromViewName(const string& strViewName) const {
    // ܂葬x͗v̂ŐɏB
    for (std::map<int, int>::const_iterator it = m_oId2Index.begin(); it != m_oId2Index.end(); ++it) {
        if (strViewName == GetViewName(it->second)) {
            return it->first;
        }
    }
    return -1;
}

const string& CKeyConfig::GetViewNameFromId(int nHotKeyId) const {
    std::map<int, int>::const_iterator it = m_oId2Index.find(nHotKeyId);
    if (it == m_oId2Index.end()) {
        return string::Empty;
    }
    return GetViewName(it->second);
}

}// namespace Themis
