#pragma once
#include "Fint.h"
#include <math.h>
namespace Themis {

/**
 * 0`n2Pi-1360x(2)
 *
 * FcosTable[n2Pi * 0 / 4]  cos  0  sin 90  1
 *     cosTable[n2Pi * 2 / 4]  cos 90  0
 *     cosTable[n2Pi * 3 / 4]  sin  0  0
 */
class CSinTable : private boost::noncopyable {
    fint cosTable[n2Pi];
public:
    CSinTable() {
        const double dPi = 3.1415926535897932384626433832795;
        for (int i=0; i<n2Pi; i++) {
            cosTable[i] = ToFint(cos(2*dPi * i/n2Pi));   //0 ` 2
        }
    }
    ~CSinTable() {}

    BOOST_STATIC_CONSTANT(int, n2Pi = 0x1000);

    fint Sin(int n) { return cosTable[(n + n2Pi*3/4) % n2Pi]; }
    fint Cos(int n) { return cosTable[n % n2Pi]; }
};

//////////////////////////////////////////////////////////////////////

/**
    wIȊ֐ƂKɁB
*/
class CMath : private boost::noncopyable {
public:
    /// n̂Ȃrgݍ킹̌擾
    static unsigned Combi(int n, int r) {
        return CombiImpl(n, r, unsigned(0));
    }
    /// n̂Ȃrgݍ킹̌擾
    static uint64_t CombiHuge(int n, int r) {
        return CombiImpl(n, r, uint64_t(0));
    }

    /** n̂Ȃrgݍ킹񋓂ăR[obNB
     * R[obNfalseԂ炻ŒfBanTake[]ɂ́A0`n-1\[grĂB
     * @param fnCallback   bool Callback(const int anTake[], int r);
     * @retval true        Ō܂ŌvZIAn̒l0ȉ̏ꍇB
     * @retval false       fnCallbackfalseԂArŌvZfꂽꍇB
     */
    template<class Fn> static bool EnumConbi(int n, int r, Fn fnCallback) {
        if (0 < n) {
            boost::scoped_array<int> anBuffer(new int[r]);
            return InnerEnumConbi(n, r, anBuffer.get(), fnCallback);
        }
        return true;
    }

private:
    template<class T> T CombiImpl(int n, int r, T dummy) {
        if (n < r || r <= 0) return 0;
        if (n == r || r == 1)  return n;
        boost::scoped_array<T> an(new T[r+1]); //pXJ̎Op`쐬
        an[0] = 1;
        for (int i = 1; i < r + 1; i++) {
            an[i] = 0;
        }
        for (int j = 0; j < n; j++) {
            for (int k = r; 0 < k; k--) {
                an[k] += an[k - 1];
            }
        }
        return = an[r];
    }
    /// EnumConbi̎p֐
    template<class Fn> static inline bool InnerEnumConbi(
        int nSize, int r, int anBuffer[], Fn fnCallback, int nTaked=0, int nResolution=0) {
        //nSize         Ŝ̐
        //r             鐔
        //nTaked        
        //nResolution   ċA(O`nSize)
        //߂l        ʏtrueAR[obNfalseԂď𒆒fƂfalse
        if (nTaked == r) {
            const int* an = const_cast<const int*>(anBuffer);
            if (!fnCallback(an, r))
                return false; //f
        } else if (nSize-nResolution < r-nTaked) {
            //ȏċAĂr܂őȂꍇ
        } else { //(nResolution < nSize)
            //nResolutionԖڂꍇ
            anBuffer[nTaked] = nResolution;
            if (!InnerEnumConbi(nSize, r, anBuffer, fnCallback, nTaked+1, nResolution+1))
                return false;
            //Ȃꍇ
            if (!InnerEnumConbi(nSize, r, anBuffer, fnCallback, nTaked, nResolution+1))
                return false;
        }
        return true;
    }
};

}
