#pragma once
#include "DataObject.h"
class CListBox;
class CEdit;
namespace Themis {

/**
    MFC̃wp[֐Ƃ
*/
class CMfcHelper : private boost::noncopyable {
public:
    //@{ Xg{bNX
    static void Add(::CListBox& rList, const string& str) {
        rList.AddString(Encoding::GetDefault().GetBytes(str).c_str());
        rList.SetCurSel(rList.GetCount() - 1);
    }
    static void Set(::CListBox& rList, int i, const string& str) {
        rList.DeleteString(i);
        rList.InsertString(i, Encoding::GetDefault().GetBytes(str).c_str());
        rList.SetCurSel(i);
    }
    static void Remove(::CListBox& rList, int i) {
        rList.DeleteString(i);
        rList.SetCurSel(i - 1);
    }
    static void Up(::CListBox& rList, int i) {
        ::CString str;
        rList.GetText(i, str);
        rList.DeleteString(i);
        rList.InsertString(i - 1, str);
        rList.SetCurSel(Themis::Max(i - 1, 0));
    }
    static void Down(::CListBox& rList, int i) {
        ::CString str;
        rList.GetText(i, str);
        rList.DeleteString(i);
        rList.InsertString(i + 1, str);
        rList.SetCurSel(i + 1);
    }
    //@}
    //@{ GfBbg{bNX
    static string GetStr(::CEdit& rEdit) {
        ::CString str;
        rEdit.GetWindowText(str);
        return string(str);
    }
    static int GetNum(::CEdit& rEdit) {
        return AtoI(GetStr(rEdit));
    }
    static void SetStr(::CEdit& rEdit, const string& str) {
        rEdit.SetWindowText(Encoding::GetDefault().GetBytes(str).c_str());
    }
    static void SetNum(::CEdit& rEdit, int n) {
        SetStr(rEdit, ItoA(n));
    }
    class CEditData : public CDataObjectBase<CEditData, string> {
        ::CEdit& m_rEdit;
    public:
        CEditData(::CEdit& rEdit) : m_rEdit(rEdit) {}
        void Set(TValueParam oValue) { SetStr(m_rEdit, oValue); }
        TValue Get() const { return GetStr(m_rEdit); }
    };
    static CEditData Data(::CEdit& rEdit) { return rEdit; }
    //@}

private:

};

}
