#pragma once
#include "tpl/smart_ptr_vector.h"
namespace Themis {

/**
    ύXꂽǂŔoIuWFNgB
*/
class IModifiable {
public:
    virtual ~IModifiable() {}
    virtual bool IsModified() const = 0;
    virtual void ClearModified() = 0;
};

/**
    IModifiablẽXgIuWFNgB
*/
class CModifiableList : private boost::noncopyable {
public:
    CModifiableList();
    ~CModifiableList();

    /// Sč폜
    void Clear();
    /// IModifiable̒ǉ
    void Add(const std::tr1::shared_ptr<IModifiable>& pMod);

    /// ύXĂtrue
    bool IsModified() const;
    /// Ă΂ꂽ_ł̏ԂAύXĂȂɂ
    void ClearModified();

private:
    smart_ptr_vector<IModifiable>   m_vctList;
};

//------------------------------------------------------------------//
}
#include "Window.h"
namespace Themis {

/// GfBbg{bNX(OS̃tO͎g킸Ǝɏ)
class CModifiableEdit : public IModifiable {
public:
    CModifiableEdit(HWND hCtrl);
    virtual bool IsModified() const;
    virtual void ClearModified();
private:
    const CEditbox      m_oCtrl;
    string              m_str;
};
/// R{{bNX
class CModifiableCombo : public IModifiable {
public:
    CModifiableCombo(HWND hCtrl);
    virtual bool IsModified() const;
    virtual void ClearModified();
private:
    const CCombobox     m_oCtrl;
    string              m_str;
};
/// `FbN{bNX
class CModifiableCheck : public IModifiable {
public:
    CModifiableCheck(HWND hCtrl);
    virtual bool IsModified() const;
    virtual void ClearModified();
private:
    const CCheckbox     m_oCtrl;
    bool                m_b;
};
/// Xg{bNX̃`FbN{bNX
class CModifiableListCheck : public IModifiable {
public:
    CModifiableListCheck(HWND hCtrl);
    virtual bool IsModified() const;
    virtual void ClearModified();
private:
    const CListview     m_oCtrl;
    vector<bool>        m_vct;
};

/**
    _CAOCModifiableListB

    ύXꂽ *  (XV) ^Cgo[Ȃǂɕt鏈ƂŁA
    WM_COMMANDł閈IsModified()̂͂ɏdCB
    ܊pGfBbg{bNX̃Xg񂾂A
    WM_COMMANDEN_CHANGEĂ̂o邩񂪁BB

     ƂvĂ̂́AۂĂ݂債Ɩ̂łƂ肠Ăׂ݂B


    RsypTv
@code

namespace Themis {
    class CModifiableCtrlList;
}

@endcode@code

    auto_ptr<CModifiableCtrlList> m_pModifiable;

@endcode@code

#include <Themis/Modifiable.h>

@endcode@code

    // WM_INITDIALOG
        m_pModifiable.reset(new CModifiableCtrlList(GetDialog()));
        m_pModifiable->Add(IDC_EDIT1);
        m_pModifiable->Add(IDC_EDIT2);
        m_pModifiable->Add(IDC_COMBO1);
        m_pModifiable->Add(IDC_COMBO2);
        m_pModifiable->Add(IDC_RADIO1);
        m_pModifiable->Add(IDC_RADIO2);
        m_pModifiable->Add(IDC_CHECK1);
        m_pModifiable->Add(IDC_CHECK2);

@endcode@code

    // WM_CLOSEƂ
        if (m_pModifiable->IsModified() && GetDialog().MsgBoxYesNo(L"mF", L"ύXĂ܂Bs܂?") != IDYES) {
            return true; // WM_CLOSEȂAƂɂΕȂB
        }

@endcode@code

    // f[^̓ǂݍ݌Ƃ
        m_pModifiable->ClearModified();

@endcode


    ܂AȂ̂AddHoge()Ȋɒu邽߂̏GۗpK\B
    uConfig.Hoge(L"") << CEditboxData(GetDialog(), IDC_EDIT1);v
@verbatim
    []      ^([ \t]+).*(IDC_[A-Z0-9]+).*$
    [u]      \1m_pModifiable->AddEdit(\2);
@endverbatim
     \[XIDPsɕ͖̂ΉBusA󔒁A*AIDC_*A*Asvu邾B
    AddEditAddComboƂւ͎蓮ōXɒuĎgׂB

*/
class CModifiableCtrlList : public CModifiableList {
public:
    CModifiableCtrlList(CWindow& rWindow);
    ~CModifiableCtrlList();

    void Add(const std::tr1::shared_ptr<IModifiable>& p) { CModifiableList::Add(p); }
    void Add(int nCtrlId);
    /// std::tr1::shared_ptrexplicitזȂ̂ŃI[o[[hĂ܂Bc܂H
    void Add(IModifiable* p) { CModifiableList::Add(std::tr1::shared_ptr<IModifiable>(p)); }

private:
    CWindow&    m_rWindow;
};

}
