#pragma once
#include "Utility/Algorithm.h"
namespace Themis {

class WorkerThreadController;

/**
    тpɍLbVǗNXB

    f[^̓ǂݍ݂Ƃ͔hNXCɂāAǂ݋@\̒񋟂sB

    \ static_cast Ȃ dynamic_cast KvsǁA
    ̕ӂ͉䖝ĎgׂB


    PrepareForwardPage()PrepareBackwardPage()́A̈̂łꍇ̂Œӂ邱ƁB
    ꂩrPriorƂrNextClearPage()Ăǂݍ܂ĂȂꍇB
    ̏ꍇClearÕf[^ɊÂĐݒ肷悤ɁB

*/
class CPageLoaderBase {
public:
    /**
        LbVf[^̊NXB

        hēKɕϐ肵ĎgׂB
        R virtual void Load() = 0; Ƃ΃_ELXgȂčςނȂǁA
        ꂾƎʓ|ȋĈŁAǂݍݏƂ͔hNXɔC鎖ɂB
    */
    struct IPageData { virtual ~IPageData() {} };
    struct ILoadData { virtual ~ILoadData() {} };

public:
    CPageLoaderBase();
    ~CPageLoaderBase();

    /// LbV̐ݒ
    void SetCacheCount(int nCache, int nForward);
    /// LbV̎擾(ForwardCount + 1 + BackwardCount)
    int GetCacheCount() const { return static_cast<int>(m_vctCaches.size()); }
    /// őOǂݐ̎擾
    int GetForwardCount() const { return m_nForwardCount; }
    /// őǂݐ̎擾
    int GetBackwardCount() const { return GetCacheCount() - GetForwardCount() - 1; }
    /// oĂ̂ǂ
    bool IsReady() const { return !m_vctCaches.empty(); }

    /// ̃y[W
    void ToNextPage();
    /// Õy[W
    void ToPriorPage();
    /// ݂̃y[WȊOēǂݍ
    void ReloadCachePage();
    /// ReloadCurrentPage() + ReloadCachePage()
    void ReloadAllPage();

    /// ݂̃y[WǂݍݒȂI܂ő҂
    void WaitLoadPage();
    /// ǂݏJn
    void StartLoadBeforehand();

    /// ݂̃y[WǂݍݏIĂ̂ǂ
    bool IsReadyCurrentPage() const { return GetCache(m_nCurrent).state == eCacheStateLoaded; }
    /// ݂̃y[W̎擾
    IPageData& GetCurrentPage() const { return *GetCache(m_nCurrent).pageData; }
    //@{ ݂̃y[W̑OO擾
    IPageData& GetPriorPage() const { return *GetCache(InnerGetRotatedIndex(m_nCurrent - 1)).pageData; }
    IPageData& GetNextPage() const { return *GetCache(InnerGetRotatedIndex(m_nCurrent + 1)).pageData; }
    //@}

    /// rIuWFNg̎擾BhNXɂǂݍ݂Ɋւϐ͂͂Ȃ̂ŁAŔrBcDLȂ _no
 // boost::recursive_mutex& GetPageLoaderExclusion() const { return mutex; }
    // hNX͕ʂmutexĔrׂB

protected:
    /// т݂[ȃ^C~O̊֌WŃoO鎖̂ŁAhNXňꑫɌnsɌĂяoBfXgN^ŌĂłƈS
    void Dispose();

private:
    /// 쐬
    virtual std::tr1::shared_ptr<IPageData> CreatePage() = 0;
    /// ^j
    virtual void ClearPage(IPageData& rPage) = 0;

    /// ǂݍݏBrĂԂŌĂяoB
    virtual std::tr1::shared_ptr<ILoadData> PrepareLoadPage(IPageData& rPage) = 0;
    /// ǂݍ
    virtual bool LoadPage(ILoadData& rLoad) = 0;
    /// ǂݍ݌nBǂݍݐ݂̂ɁArĂԂŌĂяoB
    virtual void DisposeLoadPage(IPageData& rPage, ILoadData& rLoad) = 0;

    /// ݂̃y[W̓ǂݍݏ
    virtual void PrepareCurrentPage(IPageData& rPage) = 0;
    /// ̓ǂݍݏ
    virtual void PrepareForwardPage(IPageData& rPage, IPageData& rPrior) = 0;
    /// O̓ǂݍݏ
    virtual void PrepareBackwardPage(IPageData& rPage, IPageData& rNext) = 0;

    /// CurrentPageςCxgB
    virtual void CurrentPageChanged() {}

private:
    enum ECacheState {
        eCacheStateEmpty, // ǂݍ
        eCacheStateLoading, // ǂݍݒ
        eCacheStateLoaded, // ǂݍݍς
        eCacheStateLoadFailed, // ǂݍݎs
    };
    /// State0:ǂݍ݁A1:ǂݍݒA2:ǂݍݍς݁A-1:sƂB
    struct SCache {
        ECacheState state;
        std::tr1::shared_ptr<IPageData> pageData;
        SCache(const std::tr1::shared_ptr<IPageData>& p) : state(eCacheStateEmpty), pageData(p) {}
    };

    void InnerClearPage(int i);
    void InnerPrepareCurrentPage(int i);
    void InnerPrepareForwardPage(int i);
    void InnerPrepareBackwardPage(int i);
    void InnerLoadCurrent();

    void OnThread();
    bool FindToLoad(int& cacheIndex, int& neighborIndex, bool& forward);
    void OnEndLoad(int nCurrent, bool bSucceed);

    int InnerGetRotatedIndex(int i) const { return GetRotatedIndex(i, GetCacheCount()); }

    SCache& GetCache(int i) { return m_vctCaches[i]; }
    const SCache& GetCache(int i) const { return m_vctCaches[i]; }

private:
    boost::ptr_deque<SCache> m_vctCaches;
    int m_nForwardCount; // LbV̍őOǂݐ

    int m_nCurrent; // ݂̃LbV

    volatile bool threadValid;
    std::tr1::shared_ptr<WorkerThreadController> thread;
    boost::recursive_mutex mutex;
    boost::condition cacheCondition; // ǂݍރLbVꍇɐǂ݃Xbh҂ƂɎg
    boost::condition loadingCondition; // WaitLoadPage()ȎɎg
};

}
