#pragma once
#include <boost/tr1/random.hpp>
namespace Themis {

/// 擾C^[tF[XBT͔hNXB
template<class T> class IRand : private boost::noncopyable {
public:
    //virtual ~IRand() {}

    /// ̎擾
    inline unsigned operator()() {
        return static_cast<T*>(this)->Get();
    }
    /// 0|nRange-1̗擾
    inline unsigned operator()(unsigned nRange) {
        Themis_DebugAssert(0 < nRange);
        Themis_DebugAssert(nRange <= static_cast<const T*>(this)->GetMax());
        return operator()() % nRange;
    }
    /// nMin-nMax-1̗擾
    inline unsigned operator()(unsigned nMin, unsigned nMax) {
        return operator()(nMax - nMin) + nMin;
    }

    /// ̍ől擾
 // inline unsigned GetMax() const {
 //     return static_cast<const T*>(this)->GetMax();
 // }
};

/**
    Mersenne Twister@ɂ鍂x[`B

    rand()΂̏ȂdƂpB

    Rsyp
@code

    CRand& rRand = CRand::Get();

@endcode

*/
class CRand : public IRand<CRand> {
    std::tr1::mt19937 mt;
public:
    CRand() { RandomizeCarefully(); }
    CRand(unsigned nSeed) { SetSeed(nSeed); }

    /**
        W[Ŝŋʂ̃CX^X擾B

        ʂSeedKvȏꍇĂ͕̂ʂ͂܂薳A
        gтɍ̂ǂƎv̂ŁB
    */
    static CRand& GetInstance();

    /// ̎Zbg
    void SetSeed(unsigned nSeed) { mt.seed(nSeed); }
    /// ̎Zbg(z)
    template<int N> void SetSeed(unsigned (& keys)[N]) {
        BOOST_STATIC_ASSERT(N == std::tr1::mt19937::state_size);
        mt.seed(SeedGenerator(keys));
    }
    /// ݂̎ԂȂǂKɎɂ
    void Randomize();
    /// ORandomize()
    void RandomizeCarefully();

    unsigned Get() { return mt(); }
    unsigned GetMax() const {
        #undef min
        #undef max
        BOOST_ASSERT(mt.min () == 0);
        return mt.max ();
    }

private:
    class SeedGenerator {
        unsigned* keys;
        int i;
    public:
        inline SeedGenerator(unsigned* keys) : keys(keys), i(0) {}
        inline unsigned operator()() {
            BOOST_ASSERT(i < std::tr1::mt19937::state_size);
            return keys[i++];
        }
    };
};


}
