#include "stdafx.h"
#include "MsgHook.h"
#include "RectSelector.h"
namespace Themis {

CRectSelector::CRectSelector(): m_hWnd(NULL), m_nState1(0) {
}

CRectSelector::~CRectSelector() {
}

void CRectSelector::SetWindow(HWND hWnd) {
    m_hWnd = hWnd;
}

namespace {
    bool IsInPoint(int nPoint, int nMin, int nMax) {
        return nMin - 5 <= nPoint && nPoint <= nMax + 5; // 5sNZ]TL
    }
    bool IsNearPoint(int nPoint, int nOrg) {
        return abs(nOrg - nPoint) <= 5; // }5sNZȂtrue
    }
}
void CRectSelector::OnButtonDown(bool bEnable) {
    if (!bEnable) {
        m_nState1 = 0; // Iɂ
    } else {
        CPoint ptCursor = GetCursorPos();
        m_ptDragBegin = ptCursor; // RsyՂ悤Ƀ[JɁB
        m_bDragMoved = false;
        if (m_nState1 == 0) { // I
            // IJn
            m_nState1 = 1;
            // ÔߓKɐݒ
            m_rcSelect.left = ptCursor.x;
            m_rcSelect.top = ptCursor.y;
            m_rcSelect.right = ptCursor.x;
            m_rcSelect.bottom = ptCursor.y;
            ::SetCapture(m_hWnd);
        } else if (1 <= m_nState1 && m_nState1 <= 3) { // I or TCY or ړ
            // ǂ̂悭񂯂(_uNbNƂH)
            // Ƃ肠Iɂ
            if (m_nState1 != 0) {
                m_nState1 = 0;
                ::InvalidateRect(m_hWnd, NULL, FALSE);
            }
        } else if (m_nState1 == 4) { // Iς
            bool bLeft = IsInPoint(ptCursor.y, m_rcSelect.top, m_rcSelect.bottom) && IsNearPoint(ptCursor.x, m_rcSelect.left);
            bool bTop = IsInPoint(ptCursor.x, m_rcSelect.left, m_rcSelect.right) && IsNearPoint(ptCursor.y, m_rcSelect.top);
            bool bRight = IsInPoint(ptCursor.y, m_rcSelect.top, m_rcSelect.bottom) && IsNearPoint(ptCursor.x, m_rcSelect.right);
            bool bBottom = IsInPoint(ptCursor.x, m_rcSelect.left, m_rcSelect.right) && IsNearPoint(ptCursor.y, m_rcSelect.bottom);
            // TCY
            if (bLeft && bTop) { m_nState1 = 2;  m_nState2 = 0;  ::SetCapture(m_hWnd); } else if (bRight && bTop) { m_nState1 = 2;  m_nState2 = 1;  ::SetCapture(m_hWnd); } else if (bLeft && bBottom) { m_nState1 = 2;  m_nState2 = 2;  ::SetCapture(m_hWnd); } else if (bRight && bBottom) { m_nState1 = 2;  m_nState2 = 3;  ::SetCapture(m_hWnd); } else if (bLeft) { m_nState1 = 2;  m_nState2 = 4;  ::SetCapture(m_hWnd); } else if (bTop) { m_nState1 = 2;  m_nState2 = 5;  ::SetCapture(m_hWnd); } else if (bRight) { m_nState1 = 2;  m_nState2 = 6;  ::SetCapture(m_hWnd); } else if (bBottom) { m_nState1 = 2;  m_nState2 = 7;  ::SetCapture(m_hWnd); }
            // ړ
            else if (m_rcSelect.IsIn(ptCursor)) {
                m_nState1 = 3;
                ::SetCapture(m_hWnd);
            }
            // I
            else {
                m_nState1 = 0;
                ::InvalidateRect(m_hWnd, NULL, FALSE);
            }
        }
    }
}

void CRectSelector::OnButtonUp() {
    if (1 <= m_nState1 && m_nState1 <= 3) { // TCY or I or ړ
        if (m_bDragMoved) {
            m_nState1 = 4;
        } else {
            m_nState1 = 0;  // SĂȂΖIԂɂ
            ::InvalidateRect(m_hWnd, NULL, FALSE);
        }
    }
    ::ReleaseCapture();
}

namespace {
    void SetMinMax(long& nMin, long& nMax, long x, long y) {
        if (x < y)  { nMin = x;  nMax = y; } else        { nMin = y;  nMax = x; }
    }
}
void CRectSelector::OnCursorMove() {
    m_bDragMoved = true; // xłtrue
    CPoint ptCursor = GetCursorPos();
    if (m_nState1 == 1) { // I
        SetMinMax(m_rcSelect.left, m_rcSelect.right, ptCursor.x, m_ptDragBegin.x);
        SetMinMax(m_rcSelect.top, m_rcSelect.bottom, ptCursor.y, m_ptDragBegin.y);
        // \XV
        ::InvalidateRect(m_hWnd, NULL, FALSE);
    } else if (m_nState1 == 2) { // TCY
        CSize szMove = ptCursor - m_ptCursor;
        switch (m_nState2) {
        case 0: m_rcSelect.left += szMove.cx;  m_rcSelect.top += szMove.cy; break; // 
        case 1: m_rcSelect.right += szMove.cx;  m_rcSelect.top += szMove.cy; break; // E
        case 2: m_rcSelect.left += szMove.cx;  m_rcSelect.bottom += szMove.cy; break; // 
        case 3: m_rcSelect.right += szMove.cx;  m_rcSelect.bottom += szMove.cy; break; // E
        case 4: m_rcSelect.left += szMove.cx; break; // 
        case 5: m_rcSelect.top += szMove.cy; break; // 
        case 6: m_rcSelect.right += szMove.cx; break; // E
        case 7: m_rcSelect.bottom += szMove.cy; break; // 
        }
        // \XV
        ::InvalidateRect(m_hWnd, NULL, FALSE);
    } else if (m_nState1 == 3) { // ړ
        CSize szMove = ptCursor - m_ptCursor;
        m_rcSelect.left += szMove.cx;
        m_rcSelect.right += szMove.cx;
        m_rcSelect.top += szMove.cy;
        m_rcSelect.bottom += szMove.cy;
        // \XV
        ::InvalidateRect(m_hWnd, NULL, FALSE);
    }
    // ݂̈ʒuo֕ۑ
    m_ptCursor = ptCursor;
}

bool CRectSelector::OnSetCursor() {
    if (m_nState1 == 0) {
        return false;
    }
    CPoint ptCursor = GetCursorPos();
    bool bLeft = IsInPoint(ptCursor.y, m_rcSelect.top, m_rcSelect.bottom) && IsNearPoint(ptCursor.x, m_rcSelect.left);
    bool bTop = IsInPoint(ptCursor.x, m_rcSelect.left, m_rcSelect.right) && IsNearPoint(ptCursor.y, m_rcSelect.top);
    bool bRight = IsInPoint(ptCursor.y, m_rcSelect.top, m_rcSelect.bottom) && IsNearPoint(ptCursor.x, m_rcSelect.right);
    bool bBottom = IsInPoint(ptCursor.x, m_rcSelect.left, m_rcSelect.right) && IsNearPoint(ptCursor.y, m_rcSelect.bottom);
    // TCY
    if (bLeft && bTop) { ::SetCursor(GetSystemCursor(1)); }
    else if (bRight && bTop) { ::SetCursor(GetSystemCursor(2)); }
    else if (bLeft && bBottom) { ::SetCursor(GetSystemCursor(2)); }
    else if (bRight && bBottom) { ::SetCursor(GetSystemCursor(1)); }
    else if (bLeft) { ::SetCursor(GetSystemCursor(4)); }
    else if (bTop) { ::SetCursor(GetSystemCursor(3)); }
    else if (bRight) { ::SetCursor(GetSystemCursor(4)); }
    else if (bBottom) { ::SetCursor(GetSystemCursor(3)); }
    else if (m_rcSelect.IsIn(ptCursor)) { // ړ
        ::SetCursor(GetSystemCursor(0));
    } else { // ꍇ
        return false;
    }
    return true;
}

void CRectSelector::OnPaint(const PAINTSTRUCT& ps) {
    if (m_nState1 != 0) {
        HPEN hPen = ::CreatePen(PS_DOT, 1, RGB(0, 0, 0));
        HPEN hPenOld = (HPEN)::SelectObject(ps.hdc, hPen);
        ::MoveToEx(ps.hdc, m_rcSelect.left, m_rcSelect.top, NULL);
        ::LineTo(ps.hdc, m_rcSelect.right, m_rcSelect.top);
        ::LineTo(ps.hdc, m_rcSelect.right, m_rcSelect.bottom);
        ::LineTo(ps.hdc, m_rcSelect.left, m_rcSelect.bottom);
        ::LineTo(ps.hdc, m_rcSelect.left, m_rcSelect.top);
        ::SelectObject(ps.hdc, hPenOld);
        ::DeleteObject(hPen);
    }
}

CPoint CRectSelector::GetCursorPos() {
    Themis_DebugAssert(m_hWnd != NULL);
    CPoint pt;
    ::GetCursorPos(&pt);
    ::ScreenToClient(m_hWnd, &pt);
    return pt;
}

HCURSOR CRectSelector::GetSystemCursor(int nCursor) {
    static HCURSOR ahCursor[5] = {0};
    static bool bInit = false;
    if (!bInit) {
        ahCursor[0] = ::LoadCursor(NULL, IDC_SIZEALL);
        ahCursor[1] = ::LoadCursor(NULL, IDC_SIZENWSE); // EE
        ahCursor[2] = ::LoadCursor(NULL, IDC_SIZENESW); // EE
        ahCursor[3] = ::LoadCursor(NULL, IDC_SIZENS); // ㉺
        ahCursor[4] = ::LoadCursor(NULL, IDC_SIZEWE); // E
        bInit = true;
    }
    return ahCursor[nCursor];
}

}
