/** @file
 * IuWFNg̓ԂoCif[^ׂ̃NXB
 *
 * boost::serializationĂ̂͂ǂȂ񂾂BB
 *
 * @author aki.
 */
#pragma once
#include "Utility/Algorithm.h"
namespace Themis {

class ISerializer;
class IRestorer;

/** VACY\ȃIuWFNg

    ֐͈ȉ̓B
    void OnSerialize(ISerializer& r) const;
    void OnRestore(IRestorer& r);

    }NgLXggŉȂ肩˂Ȃ̂ŁA
    SerializerERestorerɂ́AIuWFNgFactory͊܂߂ȂɂB
    AReiT::element_typẽftHgRXgN^
    Rs[RXgN^Ă΂̂ŁA̕Ӓӂ邱ƁB

    RgƂɃZ[uE[hɊւ֐U΂ɁA
    Ԃ厖Ȃ̂ŁA`ς肤̂ɂ͓KȂ̂Œӂ邱ƁB
*/
class ISerializable {
public:
    virtual ~ISerializable() {}
    virtual void OnSerialize(ISerializer& r) const = 0;     //Save
    virtual void OnRestore(IRestorer& r) = 0;               //Load
};

//////////////////////////////////////////////////////////////////////

/**
    SaveIuWFNg̃C^[tF[X
*/
class ISerializer: public ISerializable, private boost::noncopyable {
public:
    virtual ~ISerializer() {}
    //@{ v~eBuf[^
    void operator<<(const signed char& v) { InnerSerialize(&v, sizeof(v)); }
    void operator<<(const signed short& v) { InnerSerialize(&v, sizeof(v)); }
    void operator<<(const signed int& v) { InnerSerialize(&v, sizeof(v)); }
    void operator<<(const signed long& v) { InnerSerialize(&v, sizeof(v)); }
    void operator<<(const unsigned char& v) { InnerSerialize(&v, sizeof(v)); }
    void operator<<(const unsigned short& v) { InnerSerialize(&v, sizeof(v)); }
    void operator<<(const unsigned int& v) { InnerSerialize(&v, sizeof(v)); }
    void operator<<(const unsigned long& v) { InnerSerialize(&v, sizeof(v)); }
    void operator<<(const float& v) { InnerSerialize(&v, sizeof(v)); }
    void operator<<(const double& v) { InnerSerialize(&v, sizeof(v)); }
    void operator<<(const bool& v) { InnerSerialize(&v, sizeof(v)); }
    //@}
    //@{ \
    void operator<<(const CPoint& v) { InnerSerialize(&v, sizeof(v)); }
    void operator<<(const CSize& v) { InnerSerialize(&v, sizeof(v)); }
    void operator<<(const CRect& v) { InnerSerialize(&v, sizeof(v)); }
    //@}
    /// 
    void operator<<(const pair<const void*, size_t>& p) { InnerSerialize(p.first, p.second); }
    /// ISerializableȃIuWFNg
    void operator<<(const ISerializable& rObj) { rObj.OnSerialize(*this); }
    /// 
    void operator<<(const string& str);
    /// pair
    template<class T, class U> void operator<<(const pair<T, U>& p) {
        *this << p.first;
        *this << p.second;
    }
    /// std::vector
    template<class T> void operator<<(const vector<T>& c) {
        *this << static_cast<unsigned int>(c.size());
        for (typename vector<T>::const_iterator it = c.begin(); it != c.end(); ++it) {
            *this << *it;
        }
    }
    /// std::list
    template<class T> void operator<<(const std::list<T>& c) {
        *this << static_cast<unsigned int>(c.size());
        for (typename std::list<T>::const_iterator it = c.begin(); it != c.end(); ++it) {
            *this << *it;
        }
    }
    /// std::set
    template<class T> void operator<<(const std::set<T>& c) {
        *this << static_cast<unsigned int>(c.size());
        for (typename std::set<T>::const_iterator it = c.begin(); it != c.end(); ++it) {
            *this << *it;
        }
    }
    /// std::map
    template<class K, class T> void operator<<(const std::map<K, T>& c) {
        *this << static_cast<unsigned int>(c.size());
        for (typename std::map<K, T>::const_iterator it = c.begin(); it != c.end(); ++it) {
            *this << (*it).first;
            *this << (*it).second;
        }
    }

protected:
    ISerializer() {}
    ISerializer(const vector<uint8_t>& r): m_oBuffer(r) {}
    vector<uint8_t>& GetBuffer() { return m_oBuffer; }
    const vector<uint8_t>& GetBuffer() const { return m_oBuffer; }

private:
    inline void InnerSerialize(const void* p, size_t n) {
        m_oBuffer.insert(m_oBuffer.end(), static_cast<const uint8_t*>(p), static_cast<const uint8_t*>(p) + n);
    }
    void OnSerialize(ISerializer& r) const;
    void OnRestore(IRestorer& r);

    vector<uint8_t>   m_oBuffer;
};

//////////////////////////////////////////////////////////////////////

/**
    ǂݏo鑤̃IuWFNg̃C^[tF[X

    ʂȂ>>ǁAuʓ|Ȃ̂<<ŁB
*/
class IRestorer : public ISerializable, private boost::noncopyable {
public:
    virtual ~IRestorer() {}
    //@{ v~eBuf[^
    void operator<<(signed char& v) { InnerRestore(&v, sizeof(v)); }
    void operator<<(signed short& v) { InnerRestore(&v, sizeof(v)); }
    void operator<<(signed int& v) { InnerRestore(&v, sizeof(v)); }
    void operator<<(signed long& v) { InnerRestore(&v, sizeof(v)); }
    void operator<<(unsigned char& v) { InnerRestore(&v, sizeof(v)); }
    void operator<<(unsigned short& v) { InnerRestore(&v, sizeof(v)); }
    void operator<<(unsigned int& v) { InnerRestore(&v, sizeof(v)); }
    void operator<<(unsigned long& v) { InnerRestore(&v, sizeof(v)); }
    void operator<<(float& v) { InnerRestore(&v, sizeof(v)); }
    void operator<<(double& v) { InnerRestore(&v, sizeof(v)); }
    void operator<<(bool& v) { InnerRestore(&v, sizeof(v)); }
    //@}
    //@{ \
    void operator<<(CPoint& v) { InnerRestore(&v, sizeof(v)); }
    void operator<<(CSize& v) { InnerRestore(&v, sizeof(v)); }
    void operator<<(CRect& v) { InnerRestore(&v, sizeof(v)); }
    //@}
    /// 
    void operator<<(const pair<void*, size_t>& p) { InnerRestore(p.first, p.second); }
    /// ISerializableȃIuWFNg
    void operator<<(ISerializable& rObj) { rObj.OnRestore(*this); }
    /// 
    void operator<<(string& str);
    /// pair
    template<class T, class U> void operator<<(pair<T, U>& p) {
        *this << p.first;
        *this << p.second;
    }
    /// std::vector
    template<class T> void operator<<(vector<T>& c) {
        unsigned int n;
        *this << n;
        c.clear();
        c.reserve(n);
        for (unsigned int i = 0; i < n; i++) {
            T t; //Ƃ̕ӏꍇɂĂ͑xCɂȂ邯ǁBB
            *this << t;
            c.push_back(t);
        }
    }
    /// std::list
    template<class T> void operator<<(std::list<T>& c) {
        unsigned int n;
        *this << n;
        c.clear();
        for (unsigned int i = 0; i < n; i++) {
            T t;
            *this << t;
            c.push_back(t);
        }
    }
    /// std::set
    template<class T> void operator<<(std::set<T>& c) {
        unsigned int n;
        *this << n;
        c.clear();
        for (unsigned int i = 0; i < n; i++) {
            T t;
            *this << t;
            c.insert(t);
        }
    }
    /// std::map
    template<class K, class T> void operator<<(std::map<K, T>& c) {
        unsigned int n;
        *this << n;
        c.clear();
        for (unsigned int i = 0; i < n; i++) {
            K k;
            *this << k;
            *this << c[k];
        }
    }

protected:
    IRestorer(): m_nPos(0) {}
    IRestorer(const vector<uint8_t>& r): m_oBuffer(r), m_nPos(0) {}
    vector<uint8_t>& GetBuffer() { return m_oBuffer; }
    const vector<uint8_t>& GetBuffer() const { return m_oBuffer; }

private:
    inline void InnerRestore(void* p, size_t n) {
        if (GetBuffer().size() < m_nPos + n) {
            Themis_DebugWarning(L"CRestorer::InnerRestore()ŃG[");
            //ŗOôǁ[ƎvBB
        } else {
            vector<uint8_t>::iterator it = m_oBuffer.begin() + m_nPos;
            std_copy(it, it + n, static_cast<uint8_t*>(p));
            m_nPos += n;
        }
    }
    void OnSerialize(ISerializer& r) const;
    void OnRestore(IRestorer& r);

    vector<uint8_t>    m_oBuffer;
    size_t          m_nPos;
};


}
