#pragma once
#include "Char.h"
#include "String/StringBuilder.h"
namespace Themis {

/**
    𑖍ׂ̃NXB
*/
class CStringScanner : private boost::noncopyable {
public:
    CStringScanner(const string& str);

    /// ݂̕PoCgڂ擾
    wchar_t Get1() const { return m_sz[m_nPos]; }
    /// ݂̕QoCgڂ擾
    wchar_t Get2() const { return m_sz[m_nPos + 1]; }
    //@{ ̍쐬
    string Substring(int nPos) const { return m_sz.Substring(nPos); }
    string Substring(int nPos, int nLen) const { return m_sz.Substring(nPos, nLen); }
    //@}

    /// obt@̎擾
    const string& GetString() const { return m_sz; }
    /// ̒擾
    int GetLength() const { return m_sz.GetLength(); }
    /// ݈ʒu̎擾
    int GetPos() const { return m_nPos; }
    /// ݈ʒuŏ
    void ResetPos() { m_nPos = 0; }
    /// ݈ʒui߂(QoCĝQoCgڂɂȂ肵Ȃ悤ɒӂĎg)
    void AddPos(int n) { m_nPos += n; }
    /// ̕
    int ToNext();

    typedef wchar_t (CStringScanner::* unspecified_bool_type)() const;
    /// I[Ȃfalse
    operator unspecified_bool_type() const { return m_nPos < GetLength() ? &CStringScanner::Get1 : 0; }
    /// I[Ȃtrue
    bool operator!() const { return GetLength() <= m_nPos; }

    //@{ Get1()̎̕ޔ
    bool Is2Byte() const { return false; }
    bool IsSpace() const { return Char::IsWhiteSpace(Get1()) != 0; }
    bool IsBlank() const { return iswblank(Get1()) != 0; }
    bool IsAlphabet() const { return Char::IsLetter(Get1()) != 0; }
    bool IsUpper() const { return Char::IsUpper(Get1()) != 0; }
    bool IsLower() const { return Char::IsLower(Get1()) != 0; }
    bool IsDigit() const { return Char::IsDigit(Get1()) != 0; }
    bool IsHex() const { return iswxdigit(Get1()) != 0; }
    bool IsOct() const { return CChar::IsOct(Get1()) != 0; }
    bool IsBin() const { return CChar::IsBin(Get1()) != 0; }
    bool IsCSymbol() const { return CChar::IsCSymbol(Get1()) != 0; }
    bool IsCSymbolFirst() const { return CChar::IsCSymbolFirst(Get1()) != 0; }
    //@}

    int Copy1(StringBuilder& builder) { builder.Append(Get1()); AddPos(1); return 1; }
    /// 1Rs[Ď̕ցB߂l͉oCgi񂾂
    int Copy1(string& str);
    /// 1oCgRs[B(sƂ2oCgƂȂ悤ɒӂĎgׂ)
    void Copy1Byte(string& str) {
        Themis_DebugAssert(*this);
        str += string(Get1(), 1);
        AddPos(1);
    }
    /// 2oCgRs[B(sƂ1oCgƂȂ悤ɒӂĎgׂ)
    void Copy2Byte(string& str) {
        Themis_DebugAssert(IsRemainLength(2));
        str += string(Get1(), 1);
        str += string(Get2(), 1);
        AddPos(2);
    }
    /// ̂ƈv̂܂ŃRs[i
    bool CopyTo(string& str, const string& s) {
        while (*this) {
            if (IsMatch(s, s.GetLength())) {
                return true;
            } else {
                Copy1(str);
            }
        }
        return false;
    }
    /// I[܂ŃRs
    void CopyToEnd(string& str) { while (*this) { Copy1(str); } }

    /// 1oCg̔rsA炻̎܂Posi߂
    bool IsMatch(wchar_t c) {
        if (*this && Get1() == c) {
            AddPos(1);
            return true;
        } else {
            return false;
        }
    }
    /// 2oCg̔rsA炻̎܂Posi߂
    bool IsMatch(wchar_t c1, wchar_t c2) {
        if (IsRemainLength(2) && Get1() == c1 && Get2() == c2) {
            AddPos(2); return true;
        } else {
            return false;
        }
    }
    /// w蕶񂪈v邩ǂB炻̎܂Posi߂
    bool IsMatch(const string& str, size_t n) {
        const int nn = static_cast<int>(n);
        if (nn <= str.GetLength() && IsRemainLength(n) &&
            string::Compare(GetString(), GetPos(), str, 0, nn, StringComparison::CurrentCulture) == 0) {
            AddPos(nn);
            return true;
        } else {
            return false;
        }
    }
    /// boost::xpressivep}b`OB
    bool IsMatchRegex(const string& str);

    /// 1oCg̔rsA炻̎܂Posi߂
    bool IsMatchLower(wchar_t c) {
        if (*this && (wchar_t)tolower(Get1()) == c) {
            AddPos(1);
            return true;
        } else {
            return false;
        }
    }
    /// 2oCg̔rsA炻̎܂Posi߂
    bool IsMatchLower(wchar_t c1, wchar_t c2) {
        if (*this && (wchar_t)tolower(Get1()) == c1 && (wchar_t)tolower(Get2()) == c2) {
            AddPos(2);
            return true;
        } else {
            return false;
        }
    }
    /// ɂIsMatchB
    bool IsMatchLower(const string& str, size_t n) {
        const int nn = static_cast<int>(n);
        if (nn <= str.GetLength() && IsRemainLength(n) &&
            string::Compare(GetString(), GetPos(), str, 0, nn, StringComparison::CurrentCultureIgnoreCase) == 0) {
            AddPos(nn);
            return true;
        } else {
            return false;
        }
    }

    /// sł΂΂trueԂ
    bool IsMatchNewline() { return IsMatch(L'\r', L'\n') || IsMatch(L'\n'); }

    /// |C^i߂atoi()݂ȁB
    int GetDigit();
    /// GetDigit()16iŁB(AƃXy[X͏Ȃ)
    int GetHex();
    /// GetDigit()2iŁB(AƃXy[X͏Ȃ)
    int GetBin();
    /// |C^i߂atof()݂ȁB
    double GetFloat();
    /// b̕ϐȂǂ擾
    string GetLabel();

    /// ^uEpXy[X΂
    void SkipBlank() { while (IsBlank()) AddPos(1); }
    /// ^uEpXy[XEs΂Asꍇ̌Ԃ
    int SkipSpace();

    /// I[܂ncĂ邩ǂBIsRemainLength(1)*thisƓȂ̂ł̕B
    bool IsRemainLength(size_t n) {
        return int(m_nPos + n) <= GetLength();
    }

private:
    string m_sz;
    int m_nPos;
};

}
