#pragma once
#include "WndCtrl.h"
#include "Window.h"
#include "DataObject.h"
namespace Themis {

/// `FbN{bNX
class CCheckboxData : public CDataObjectBase<CCheckboxData, bool> {
public:
    inline CCheckboxData(CWindow& rDlg, int nCtrlId) : m_oCtrl(rDlg.GetCtrl(nCtrlId)) {}
    inline CCheckbox& GetCtrl() { return m_oCtrl; }
    inline void Set(TValueParam t) { m_oCtrl.SetCheck(t); }
    inline TValue Get() const { return m_oCtrl.GetCheck(); }
private:
    CCheckbox m_oCtrl;
};

/// GfBbg{bNX
class CEditboxData : public CDataObjectBase<CEditboxData, string> {
public:
    inline CEditboxData(CWindow& rDlg, int nCtrlId) : m_oCtrl(rDlg.GetCtrl(nCtrlId)) {}
    inline CEditbox& GetCtrl() { return m_oCtrl; }
    inline void Set(TValueParam t) { m_oCtrl.SetText(t); }
    inline TValue Get() const { return m_oCtrl.GetText(); }
private:
    CEditbox m_oCtrl;
};

/// X^eBbNeLXg
class CStaticData : public CDataObjectBase<CStaticData, string> {
public:
    inline CStaticData(CWindow& rDlg, int nCtrlId) : m_oCtrl(rDlg.GetCtrl(nCtrlId)) {}
    inline CStatic& GetCtrl() { return m_oCtrl; }
    inline void Set(TValueParam t) { m_oCtrl.SetText(t); }
    inline TValue Get() const { return m_oCtrl.GetText(); }
private:
    CStatic m_oCtrl;
};

/// R{{bNX
class CComboboxData : public CDataObjectBase<CComboboxData, int> {
public:
    inline CComboboxData(CWindow& rDlg, int nCtrlId) : m_oCtrl(rDlg.GetCtrl(nCtrlId)) {}
    inline CCombobox& GetCtrl() { return m_oCtrl; }
    inline void Set(TValueParam t) { m_oCtrl.SetSelected(t); }
    inline TValue Get() const { return m_oCtrl.GetSelected(); }
private:
    CCombobox m_oCtrl;
};

/// R{{bNX()
class CComboboxStrData : public CDataObjectBase<CComboboxStrData, string> {
public:
    inline CComboboxStrData(CWindow& rDlg, int nCtrlId) : m_oCtrl(rDlg.GetCtrl(nCtrlId)) {}
    inline CCombobox& GetCtrl() { return m_oCtrl; }
    inline void Set(TValueParam t) { m_oCtrl.SetSelected(t); }
    inline TValue Get() const { return m_oCtrl.Get(); }
private:
    CCombobox m_oCtrl;
};

/// Abv_E(Xs)
class CUpdownData : public CDataObjectBase<CUpdownData, int> {
public:
    inline CUpdownData(CWindow& rDlg, int nCtrlId) : m_oCtrl(rDlg.GetCtrl(nCtrlId)) {}
    inline CUpdown& GetCtrl() { return m_oCtrl; }
    inline void Set(TValueParam t) { m_oCtrl.Set(t); }
    inline TValue Get() const { return m_oCtrl.Get(); }
private:
    CUpdown m_oCtrl;
};

/// XC_[
class CSliderData : public CDataObjectBase<CSliderData, int> {
public:
    inline CSliderData(CWindow& rDlg, int nCtrlId) : m_oCtrl(rDlg.GetCtrl(nCtrlId)) {}
    inline CSlider& GetCtrl() { return m_oCtrl; }
    inline void Set(TValueParam t) { m_oCtrl.Set(t); }
    inline TValue Get() const { return m_oCtrl.Get(); }
private:
    CSlider m_oCtrl;
};

/// `FbN{bNXtXgr|
class CListviewCheckData : public CDataObjectBase<CListviewCheckData, bool> {
public:
    inline CListviewCheckData(CWindow& rDlg, int nCtrlId, int nIndex = -1) : m_oCtrl(rDlg.GetCtrl(nCtrlId)), m_nIndex(nIndex) {}
    inline CListview& GetCtrl() { return m_oCtrl; }
    inline void Set(TValueParam t) { Themis_DebugAssert(0 <= m_nIndex); m_oCtrl.SetCheck(m_nIndex, t); }
    inline TValue Get() const { Themis_DebugAssert(0 <= m_nIndex); return m_oCtrl.GetCheck(m_nIndex); }
    /// ܂B
    inline CListviewCheckData& SetIndex(int nIndex) { m_nIndex = nIndex; return *this; }
private:
    CListview m_oCtrl;
    int m_nIndex;
};

/// WI{^
class CRadiosData : public CDataObjectBase<CRadiosData, int> {
public:
    inline CRadiosData(const CRadios& rCtrl) : m_oCtrl(rCtrl) {}
    inline CRadiosData(CWindow& rDlg, int a, int b) : m_oCtrl(rDlg.GetHandle()) { m_oCtrl/a/b; }
    inline CRadiosData(CWindow& rDlg, int a, int b, int c) : m_oCtrl(rDlg.GetHandle()) { m_oCtrl/a/b/c; }
    inline CRadiosData(CWindow& rDlg, int a, int b, int c, int d) : m_oCtrl(rDlg.GetHandle()) { m_oCtrl/a/b/c/d; }
    inline CRadiosData(CWindow& rDlg, int a, int b, int c, int d, int e) : m_oCtrl(rDlg.GetHandle()) { m_oCtrl/a/b/c/d/e; }
    inline CRadiosData(CWindow& rDlg, int a, int b, int c, int d, int e, int f) : m_oCtrl(rDlg.GetHandle()) { m_oCtrl/a/b/c/d/e/f; }
    inline CRadiosData(CWindow& rDlg, int a, int b, int c, int d, int e, int f, int g) : m_oCtrl(rDlg.GetHandle()) { m_oCtrl/a/b/c/d/e/f/g; }
    inline CRadios& GetCtrl() { return m_oCtrl; }
    inline void Set(TValueParam t) { m_oCtrl.Set(t); }
    inline TValue Get() const { return m_oCtrl.Get(); }
    /// ܂B
    inline CRadiosData& operator/(int nId) { m_oCtrl / nId; return *this; }
private:
    CRadios m_oCtrl;
};

}
