#include "stdafx.h"
#include <Themis/Windows/Process.h>
#include <Themis/Windows/Environment.h>
#include <Themis/AppFrameBase.h>
#include <Themis/CommandLine.h>
#include <Themis/Allocator.h>
#include <Themis/Window.h>
#include <Themis/CommDlg.h>
#include <Themis/Config.h>
#include <Themis/File.h>
#include <Themis/TrayIcon.h>
#include <Themis/StringScanner.h>
#include <Themis/WndCtrlData.h>
#include <Themis/using.h>
#include <time.h>
#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")
#include "resource.h"


const int c_nBuildCount = 6;


class CAppWindow : private IMsgHooker {
    auto_ptr<CWindow>   m_pWindow;
    auto_ptr<CTrayIcon> m_pTrayIcon;
    CChooseFile         m_oChooseFile;
    int                 m_nRestSec;
    string              m_strTemplateFile;
    int                 m_nOption;    // 0:ʏA1:/openA2:/select

public:
    CAppWindow(): m_nRestSec(-1) {
        m_pWindow.reset(new CWindow);
        m_pWindow->GetHook().Add(this);
    }

    ~CAppWindow() {
    }

    int Run(CAppFrameBase& rAppFrame) {
        {
            CCommandLine oCmdLine(rAppFrame.GetCmdLine());
            m_nOption = 0;
            m_strTemplateFile = string::Empty;
            for (int i = 0, n = oCmdLine.GetCount(); i < n; i++) {
                if (oCmdLine.IsMatch(i, L"/open")) {
                    m_nOption = 1;
                } else if (oCmdLine.IsMatch(i, L"/select")) {
                    m_nOption = 2;
                } else {
                    if (m_strTemplateFile.GetLength() <= 0) {
                        m_strTemplateFile = oCmdLine.Get(i);
                    } else {
                        CWnd().MsgBox(L"G[", L"̃R}hCo܂F" + oCmdLine.Get(i));
                    // ۂȂꍇÂŏ㏑͍̂̌ȋĈŁBB
                    }
                }
            }
        }
        CModalDialogParameter oPrm(IDD_DIALOG1);
        m_pWindow->Create(oPrm);
        return 0;
    }

private:
    bool HookMsg(CMsgHookPrms& rPrms) {
        if (rPrms.GetMsg() == WM_TIMER) {
            m_nRestSec--;
            SetCaption();
            if (m_nRestSec < 10) {
                m_pWindow->SetIcon(GetIconId());
                if (m_pTrayIcon->IsShow()) {
                    m_pTrayIcon->SetIcon(GetIconId());
                }
            }
            if (m_nRestSec <= 0) { // I
                m_pWindow->UnsetTimer(100);
                m_pWindow->SetIcon(IDI_ICON1);
                m_pTrayIcon->UnsetIcon();
                m_pWindow->Show(); // \Ȃ\
                m_pWindow->SetForeground();

                if (m_pWindow->Checkbox(IDC_CHECK1).GetCheck()) { // r[v
                    ::Beep(443 * 2, 1000);
                }
                if (m_pWindow->Checkbox(IDC_CHECK2).GetCheck()) { // wav
                    ::PlaySound(Encoding::GetDefault().GetBytes(CFileNameModuleDir(m_pWindow->Editbox(IDC_EDIT2).GetText()).Get()).c_str(),
                        NULL, SND_FILENAME | SND_SYNC);
                }
                if (m_pWindow->Checkbox(IDC_CHECK7).GetCheck()) { // st@C
                    string strFile = m_pWindow->Editbox(IDC_EDIT6).GetText();
                    string strPrm = m_pWindow->Editbox(IDC_EDIT8).GetText();
                    // ϐ̓WJƂ
                    CFileName oCmd(strFile);
                    oCmd.SetBaseDir(string::Empty);
                    // JgfBNg̐ݒ
                    string curDirOld = Environment::GetCurrentDirectory();
                    try {
                        CFileName oCmdDir(oCmd.GetDir());
                        if (!oCmdDir.IsEmpty() && !oCmdDir.IsRelativePath()) {
                            Environment::SetCurrentDirectory(oCmdDir.RemoveDirSeparator());
                        }
                        // ^XN̋NBnShowH
                        if (strPrm.GetLength() <= 0) {
                            Process::Start(oCmd.Get());
                        } else {
                            Process::Start(oCmd.Get(), Environment::ExpandEnvironmentVariables(strPrm));
                        }
                    } catch (...) {
                        Environment::SetCurrentDirectory(curDirOld);
                        throw;
                    }
                    Environment::SetCurrentDirectory(curDirOld);
                }
                if (m_pWindow->Checkbox(IDC_CHECK3).GetCheck()) { // bZ[W
                    m_pWindow->MsgBox(L"bZ[W", m_pWindow->Editbox(IDC_EDIT7).GetText());
                }

                m_nRestSec = -1;
                SetEnableCtrl();
                SetCaption();
                if (m_pWindow->Checkbox(IDC_CHECK5).GetCheck()) { // Iɕ
                    m_pWindow->Close();
                }
            }
            return true;
        } else if (rPrms.GetMsg() == WM_COMMAND) {
            switch (rPrms.GetWPrmLoWord()) {
            case IDC_CHECK3: // msg
            case IDC_CHECK2: // wav
            case IDC_CHECK7: // exe
                SetEnableCtrl();
                break;
            case IDC_BUTTON3: // ...
                m_oChooseFile.SetTitle(L"t@C̑I");
                m_oChooseFile.ClearNameFilter();
                m_oChooseFile.AddNameFilter(L"Wave File", L"*.wav");
                m_oChooseFile.AddNameFilter(L"All Files", L"*.*");
                m_oChooseFile.SetCurrentDir(CFileName(CFileNameModuleDir(m_pWindow->Editbox(IDC_EDIT2).GetText()).GetDir()));
                m_oChooseFile.SetDefaultExt(L"wav");
                m_oChooseFile.SetDefault(CFileNameModuleDir(m_pWindow->Editbox(IDC_EDIT2).GetText()).GetPrefix());
                if (m_oChooseFile.ShowOpen()) {
                    m_pWindow->Editbox(IDC_EDIT2).SetText(m_oChooseFile.GetResult().Get());
                }
                break;
            case IDC_BUTTON5: // ...
                m_oChooseFile.SetTitle(L"st@C̑I");
                m_oChooseFile.ClearNameFilter();
                m_oChooseFile.AddNameFilter(L"Executable File", L"*.COM;*.EXE;*.BAT;*.CMD;*.VBS;*.VBE;*.JS;*.JSE;*.WSF;*.WSH");
                m_oChooseFile.AddNameFilter(L"All Files", L"*.*");
                m_oChooseFile.SetCurrentDir(CFileName(CFileNameModuleDir(m_pWindow->Editbox(IDC_EDIT6).GetText()).GetDir()));
                m_oChooseFile.SetDefaultExt(L"exe");
                m_oChooseFile.SetDefault(CFileNameModuleDir(m_pWindow->Editbox(IDC_EDIT6).GetText()).GetPrefix());
                if (m_oChooseFile.ShowOpen()) {
                    m_pWindow->Editbox(IDC_EDIT6).SetText(m_oChooseFile.GetResult().Get());
                }
                break;
            case IDC_BUTTON4: // ݂̐ݒ̫Ăɂ
                {
                    CConfig oConfig;
                    oConfig.Load();
                    SaveToTemplate(oConfig);
                    oConfig.Save();
                }
                break;
            case IDC_BUTTON1: // ڰĂƂĕۑ
                CFile(CFileNameModuleDir(L"./template/")).CreateDir();
                m_oChooseFile.SetTitle(L"ev[gƂĕۑ");
                m_oChooseFile.ClearNameFilter();
                m_oChooseFile.AddNameFilter(L"Template File", L"*.tpt");
                m_oChooseFile.SetCurrentDir(CFileNameModuleDir(L"./template/"));
                m_oChooseFile.SetDefaultExt(L"tpt");
                m_oChooseFile.SetDefault(L"");
                if (m_oChooseFile.ShowSave()) {
                    CConfig oConfig;
                    SaveToTemplate(oConfig);
                    oConfig.Save(m_oChooseFile.GetResult());
                }
                break;
            case IDC_BUTTON2: // ڰĂǂݍ
                CFile(CFileNameModuleDir(L"./template/")).CreateDir();
                m_oChooseFile.SetTitle(L"ev[gǂݍ");
                m_oChooseFile.ClearNameFilter();
                m_oChooseFile.AddNameFilter(L"Template File", L"*.tpt");
                m_oChooseFile.SetCurrentDir(CFileNameModuleDir(L"./template/"));
                m_oChooseFile.SetDefaultExt(L"tpt");
                m_oChooseFile.SetDefault(L"");
                if (m_oChooseFile.ShowOpen()) {
                    CConfig oConfig;
                    SetDefault(oConfig);
                    oConfig.Load(m_oChooseFile.GetResult());
                    LoadFromTemplate(oConfig);
                }
                break;
            case IDOK: // Jn
                m_pWindow->SetTimer(100, 1000);
                SetRestTime();
                SetEnableCtrl();
                SetCaption();
                m_pWindow->SetIcon(GetIconId());
                if (m_pWindow->Checkbox(IDC_CHECK4).GetCheck()) { // Jnŏ
                    m_pWindow->Minimize();
                }
                break;
            case IDC_BUTTON6: // f
                m_pWindow->UnsetTimer(100);
                m_pWindow->SetIcon(IDI_ICON1);
                m_nRestSec = -1;
                SetEnableCtrl();
                SetCaption();
                break;
            default:
                return false;
            }
            return true;
        } else if (rPrms.GetMsg() == WM_APP + 1) { // }EXbZ[W
            UINT nMouseMsg = m_pTrayIcon->GetMouseMsg(rPrms);
            if (nMouseMsg == WM_LBUTTONDBLCLK) {
                m_pWindow->Show(); // \Ȃ\
                m_pWindow->SetForeground();
                m_pTrayIcon->UnsetIcon();
                return true;
            }
            return false;
        } else if (m_pTrayIcon.get() != NULL && m_pTrayIcon->OnTaskbarCreate(rPrms)) { // ACRĕ\
            return true;
        } else if (rPrms.GetMsg() == WM_SIZE) {
            if (rPrms.GetWPrm() == SIZE_MINIMIZED) {
                m_pWindow->Hide();
                m_pTrayIcon->SetIcon(GetIconId());
                return true;
            }
            return false;
        } else if (rPrms.GetMsg() == WM_INITDIALOG) {
            m_pTrayIcon.reset(new CTrayIcon(m_pWindow->GetHandle(), WM_APP + 1));

            m_pWindow->SetIcon(IDI_ICON1);
            m_oChooseFile.SetOwner(m_pWindow->GetHandle());

            // ftHg̓ǂݍ
            CConfig oConfig;
            SetDefault(oConfig);
            if (!oConfig.Load()) {
                oConfig.Save();
            }

            if (0 < m_strTemplateFile.GetLength()) {
                CFileName oFileName(m_strTemplateFile, CFileNameModuleDir(L"./template/"));
                if (!oConfig.Load(oFileName)) {
                    if (!oConfig.Load(oFileName.SetSuffix(L"tpt"))) {
                        CWnd(NULL).MsgBox(L"G[", oFileName.SetSuffix(L"tpt").Get() + L" ̓ǂݍ݂Ɏs܂");
                        m_strTemplateFile = string::Empty;
                    }
                }
            }

            LoadFromTemplate(oConfig);
            SetCaption();

            if (m_nOption == 1) { // /openȏꍇBȂB
            } else if (m_nOption == 2) { // /selectȏꍇAev[g̓ǂݍ݃{^B
                m_pWindow->PostMsg(WM_COMMAND, IDC_BUTTON2, 0);
            } else if (0 < m_strTemplateFile.GetLength() && m_nOption != 1) { // ̃ev[gꍇAJn{^B
                m_pWindow->PostMsg(WM_COMMAND, IDOK, 0);
            }
            return true;
        } else if (rPrms.GetMsg() == WM_CLOSE) {
            m_pWindow->Delete();
            return true;
        } else if (rPrms.GetMsg() == WM_DESTROY) {
            m_pTrayIcon->UnsetIcon();
            return false;
        } else {
            return false;
        }
    }

    void SetDefault(CConfig& oConfig) {
        oConfig.Num(L"TimeH", 0);
        oConfig.Num(L"TimeM", 0);
        oConfig.Num(L"TimeS", 0);
        oConfig.Bool(L"TimeMode", false);
        oConfig.Bool(L"NotifyMsg", true);
        oConfig.Str(L"NotifyMsgText", L"");
        oConfig.Bool(L"NotifyBeep", false);
        oConfig.Bool(L"NotifyWav", false);
        oConfig.File(L"NotifyWavFile", L"%windir%\\Media\\chimes.wav");
        oConfig.Bool(L"NotifyExe", false);
        oConfig.File(L"NotifyExeFile", L"%comspec%");
        oConfig.File(L"NotifyExePrm", L"");
        oConfig.Bool(L"MinimizeWithStart", true);
        oConfig.Bool(L"CloseWithEnd", true);
    }
    void SaveToTemplate(CConfig& oConfig) {
        oConfig.NumData(L"TimeH") << CEditboxData(*m_pWindow, IDC_EDIT3);
        oConfig.NumData(L"TimeM") << CEditboxData(*m_pWindow, IDC_EDIT4);
        oConfig.NumData(L"TimeS") << CEditboxData(*m_pWindow, IDC_EDIT5);
        oConfig.BoolData(L"TimeMode") << CCheckboxData(*m_pWindow, IDC_CHECK6);
        oConfig.BoolData(L"NotifyMsg") << CCheckboxData(*m_pWindow, IDC_CHECK3);
        oConfig.StrData(L"NotifyMsgText") << CEditboxData(*m_pWindow, IDC_EDIT7);
        oConfig.BoolData(L"NotifyBeep") << CCheckboxData(*m_pWindow, IDC_CHECK1);
        oConfig.BoolData(L"NotifyWav") << CCheckboxData(*m_pWindow, IDC_CHECK2);
        oConfig.FileData(L"NotifyWavFile") << CEditboxData(*m_pWindow, IDC_EDIT2);
        oConfig.BoolData(L"NotifyExe") << CCheckboxData(*m_pWindow, IDC_CHECK7);
        oConfig.FileData(L"NotifyExeFile") << CEditboxData(*m_pWindow, IDC_EDIT6);
        oConfig.FileData(L"NotifyExePrm") << CEditboxData(*m_pWindow, IDC_EDIT8);
        oConfig.BoolData(L"MinimizeWithStart") << CCheckboxData(*m_pWindow, IDC_CHECK4);
        oConfig.BoolData(L"CloseWithEnd") << CCheckboxData(*m_pWindow, IDC_CHECK5);
    }
    void LoadFromTemplate(CConfig& oConfig) {
        if (!oConfig.Exists(L"TimeMode")) {
            oConfig.Bool(L"TimeMode", false);
        }
        oConfig.NumData(L"TimeH") >> CEditboxData(*m_pWindow, IDC_EDIT3);
        oConfig.NumData(L"TimeM") >> CEditboxData(*m_pWindow, IDC_EDIT4);
        oConfig.NumData(L"TimeS") >> CEditboxData(*m_pWindow, IDC_EDIT5);
        oConfig.BoolData(L"TimeMode") >> CCheckboxData(*m_pWindow, IDC_CHECK6);
        oConfig.BoolData(L"NotifyMsg") >> CCheckboxData(*m_pWindow, IDC_CHECK3);
        oConfig.StrData(L"NotifyMsgText") >> CEditboxData(*m_pWindow, IDC_EDIT7);
        oConfig.BoolData(L"NotifyBeep") >> CCheckboxData(*m_pWindow, IDC_CHECK1);
        oConfig.BoolData(L"NotifyWav") >> CCheckboxData(*m_pWindow, IDC_CHECK2);
        oConfig.FileData(L"NotifyWavFile") >> CEditboxData(*m_pWindow, IDC_EDIT2);
        oConfig.BoolData(L"NotifyExe") >> CCheckboxData(*m_pWindow, IDC_CHECK7);
        oConfig.FileData(L"NotifyExeFile") >> CEditboxData(*m_pWindow, IDC_EDIT6);
        oConfig.FileData(L"NotifyExePrm") >> CEditboxData(*m_pWindow, IDC_EDIT8);
        oConfig.BoolData(L"MinimizeWithStart") >> CCheckboxData(*m_pWindow, IDC_CHECK4);
        oConfig.BoolData(L"CloseWithEnd") >> CCheckboxData(*m_pWindow, IDC_CHECK5);

        if (m_pWindow->Editbox(IDC_EDIT3).GetText() == L"0") { m_pWindow->Editbox(IDC_EDIT3).SetText(string()); }
        if (m_pWindow->Editbox(IDC_EDIT4).GetText() == L"0") { m_pWindow->Editbox(IDC_EDIT4).SetText(string()); }
        if (m_pWindow->Editbox(IDC_EDIT5).GetText() == L"0") { m_pWindow->Editbox(IDC_EDIT5).SetText(string()); }
        SetEnableCtrl();
    }

    void SetEnableCtrl() {
        bool bEnable = m_nRestSec < 0;
        bool bMsg = m_pWindow->Checkbox(IDC_CHECK3).GetCheck();
        bool bWav = m_pWindow->Checkbox(IDC_CHECK2).GetCheck();
        bool bExe = m_pWindow->Checkbox(IDC_CHECK7).GetCheck();
        m_pWindow->Editbox(IDC_EDIT3).SetEnable(bEnable);
        m_pWindow->Editbox(IDC_EDIT4).SetEnable(bEnable);
        m_pWindow->Editbox(IDC_EDIT5).SetEnable(bEnable);
        m_pWindow->Checkbox(IDC_CHECK6).SetEnable(bEnable);

        m_pWindow->Editbox(IDC_EDIT7).SetEnable(bMsg);
        m_pWindow->Editbox(IDC_EDIT2).SetEnable(bWav);
        m_pWindow->Button(IDC_BUTTON3).SetEnable(bWav);
        m_pWindow->Editbox(IDC_EDIT6).SetEnable(bExe);
        m_pWindow->Editbox(IDC_EDIT8).SetEnable(bExe);
        m_pWindow->Button(IDC_BUTTON5).SetEnable(bExe);

        m_pWindow->Button(IDC_BUTTON2).SetEnable(bEnable);

        m_pWindow->Button(IDOK).SetEnable(bEnable);
        m_pWindow->Button(IDC_BUTTON6).SetEnable(!bEnable);
    }

    void SetRestTime() {
        m_nRestSec = m_pWindow->Editbox(IDC_EDIT3).GetInt() * 3600 +
            m_pWindow->Editbox(IDC_EDIT4).GetInt() * 60 +
            m_pWindow->Editbox(IDC_EDIT5).GetInt();
        if (m_pWindow->Checkbox(IDC_CHECK6).GetCheck()) { // w胂[h
            time_t tt = time(NULL);
            tm* t = localtime(&tt);
            m_nRestSec -= t->tm_hour * 3600 + t->tm_min * 60 + t->tm_sec; // ڕW - ݎ
            if (m_nRestSec <= 0) {
                m_nRestSec += 24 * 3600;
            }
        }
    }

    void SetCaption() {
        string str;
        if (0 <= m_nRestSec) {
            str += L"";
            if (0 < m_nRestSec / 3600) { // PԈȏȏꍇ
                str += ItoA(m_nRestSec / 3600);
                str += L"";
            }
            if (0 < m_nRestSec / 60) { // ͂PԂOƂł
                str += string::Format(L"%02d", m_nRestSec / 60 % 60);
                str += L"";
            }
            // b͖ŕ\
            str += string::Format(L"%02d", m_nRestSec % 60);
            str += L"b";
            // ؂蕶
            str += L" / ";
        }
        str += string::Format(L"܁[ build-%d", c_nBuildCount);
        m_pWindow->SetText(str);
        if (m_pTrayIcon.get() != NULL) {
            m_pTrayIcon->SetTip(str);
        }
    }

    int GetIconId() const {
        if (m_nRestSec < 10) {
            if (m_nRestSec < 0) {
                return IDI_ICON1;
            }
            switch (m_nRestSec) {
            case 9: return IDI_ICON3;
            case 8: return IDI_ICON4;
            case 7: return IDI_ICON5;
            case 6: return IDI_ICON6;
            case 5: return IDI_ICON7;
            case 4: return IDI_ICON8;
            case 3: return IDI_ICON9;
            case 2: return IDI_ICON10;
            case 1: return IDI_ICON11;
         // case 0: return IDI_ICON12;
            }
        }
        return IDI_ICON2;
    }
};

class CAppFrame: public CAppFrameBase {
    int InnerRun() {
        return CAppWindow().Run(*this);
    }
};

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow) {
    CAppFrame theApp;
    theApp.Initialize(hInstance, hPrevInstance, lpCmdLine, nCmdShow);
    return theApp.Run();
}

